// generated by Fast Light User Interface Designer (fluid) version 1.0303

#include "ADnoteUI.h"
// ADNoteUI.cc
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014-2016, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code, modified April 2011

#include <FL/Fl_Box.H>
    #include <FL/Fl_Group.H>
    #include "Params/ADnoteParameters.h"
    #include "Misc/SynthEngine.h"
    #include "WidgetPDialUI.h"
    #include "WidgetMWSliderUI.h"
    #include "FilterUI.h"
    #include "PresetsUI.h"
#include "MasterUI.h"

void ADvoicelistitem::cb_voicevolume_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
   			 o->value(100);
pars->VoicePar[nvoice].PVolume = lrint(o->value());

synth->commandFetch(o->value(), (Fl::event_button() | 0x20 | (1 << 7)), 0, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voicevolume(mwheel_val_slider_rev* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voicevolume_i(o,v);
}

void ADvoicelistitem::cb_voiceresonanceenabled_i(Fl_Check_Button* o, void*) {
  pars->VoicePar[nvoice].Presonance = lrint(o->value());
synth->commandFetch(o->value(), (Fl::event_button() | 0x20 | (1 << 7)), 130, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voiceresonanceenabled(Fl_Check_Button* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voiceresonanceenabled_i(o,v);
}

void ADvoicelistitem::cb_voicelfofreq_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
    o->value(40);
pars->VoicePar[nvoice].FreqLfo->Pintensity = lrint(o->value());

synth->commandFetch(o->value(), (Fl::event_button() | 0x20 | (1 << 7)), 1, npart, kititem, 0x80 + nvoice, 0, 1);
}
void ADvoicelistitem::cb_voicelfofreq(mwheel_val_slider_rev* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voicelfofreq_i(o,v);
}

void ADvoicelistitem::cb_voicepanning_i(WidgetPDial* o, void*) {
  pars->setVoicePan(nvoice, lrint(o->value()));

synth->commandFetch(o->value(), (Fl::event_button() | 0x20 | (1 << 7)), 2, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voicepanning(WidgetPDial* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voicepanning_i(o,v);
}

void ADvoicelistitem::cb_noiselabel_i(Fl_Box* o, void*) {
  //
    int tmp = pars->VoicePar[nvoice].Type;
    if (tmp == 0)
    {
        o->hide();
        voiceresonanceenabled->activate();
        detunevalueoutput->activate();
        voicedetune->activate();
        voicelfofreq->activate();
        voiceoscil->activate();
        return;
    }
    if (tmp == 1)
        o->labelcolor(7);
    else
        o->labelcolor(5);
    o->show();
    voiceresonanceenabled->deactivate();
    detunevalueoutput->deactivate();
    voicedetune->deactivate();
    voicelfofreq->deactivate();
    voiceoscil->deactivate();
}
void ADvoicelistitem::cb_noiselabel(Fl_Box* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_noiselabel_i(o,v);
}

void ADvoicelistitem::cb_detunevalueoutput_i(Fl_Value_Output* o, void*) {
  o->value(getDetune((pars->VoicePar[nvoice].PDetuneType == 0) ? (pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PDetuneType), 0, pars->VoicePar[nvoice].PDetune) * pars->getBandwidthDetuneMultiplier());
}
void ADvoicelistitem::cb_detunevalueoutput(Fl_Value_Output* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_detunevalueoutput_i(o,v);
}

void ADvoicelistitem::cb_voicedetune_i(mwheel_slider_rev* o, void*) {
  //
              if (Fl::event_button() == 3)
                  o->value(0);
              pars->VoicePar[nvoice].PDetune = lrint(o->value()) + 8192;
              detunevalueoutput->do_callback();
              
              synth->commandFetch(o->value(), (Fl::event_button() | 0x20 | (1 << 7)), 32, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voicedetune(mwheel_slider_rev* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voicedetune_i(o,v);
}

void ADvoicelistitem::cb_voiceenabled_i(Fl_Check_Button* o, void*) {
  //
            pars->VoicePar[nvoice].Enabled = lrint(o->value());
            if (o->value() == 0)
                voicelistitemgroup->deactivate();
            else
                voicelistitemgroup->activate();
            o->redraw();
            
            synth->commandFetch(o->value(), (Fl::event_button() | 0x20 | (1 << 7)), 129, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voiceenabled(Fl_Check_Button* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->user_data()))->cb_voiceenabled_i(o,v);
}

Fl_Group* ADvoicelistitem::make_window() {
  { ADnoteVoiceListItem = new Fl_Group(0, 0, 620, 30);
    ADnoteVoiceListItem->box(FL_ENGRAVED_BOX);
    ADnoteVoiceListItem->color(FL_BACKGROUND_COLOR);
    ADnoteVoiceListItem->selection_color(FL_BACKGROUND_COLOR);
    ADnoteVoiceListItem->labeltype(FL_NO_LABEL);
    ADnoteVoiceListItem->labelfont(0);
    ADnoteVoiceListItem->labelsize(14);
    ADnoteVoiceListItem->labelcolor(FL_FOREGROUND_COLOR);
    ADnoteVoiceListItem->user_data((void*)(this));
    ADnoteVoiceListItem->align(Fl_Align(FL_ALIGN_TOP));
    ADnoteVoiceListItem->when(FL_WHEN_RELEASE);
    { Fl_Group* o = voicelistitemgroup = new Fl_Group(50, 3, 567, 24);
      voicelistitemgroup->box(FL_FLAT_BOX);
      { mwheel_val_slider_rev* o = voicevolume = new mwheel_val_slider_rev(90, 5, 115, 20);
        voicevolume->tooltip("Volume");
        voicevolume->type(5);
        voicevolume->box(FL_THIN_DOWN_BOX);
        voicevolume->color(FL_BACKGROUND_COLOR);
        voicevolume->selection_color(FL_BACKGROUND_COLOR);
        voicevolume->labeltype(FL_NORMAL_LABEL);
        voicevolume->labelfont(0);
        voicevolume->labelsize(8);
        voicevolume->labelcolor(FL_FOREGROUND_COLOR);
        voicevolume->maximum(127);
        voicevolume->step(1);
        voicevolume->callback((Fl_Callback*)cb_voicevolume);
        voicevolume->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        voicevolume->when(FL_WHEN_CHANGED);
        o->value(pars->VoicePar[nvoice].PVolume);
      } // mwheel_val_slider_rev* voicevolume
      { Fl_Check_Button* o = voiceresonanceenabled = new Fl_Check_Button(245, 7, 15, 17);
        voiceresonanceenabled->tooltip("Resonance On/Off");
        voiceresonanceenabled->down_box(FL_DOWN_BOX);
        voiceresonanceenabled->labeltype(FL_EMBOSSED_LABEL);
        voiceresonanceenabled->labelfont(1);
        voiceresonanceenabled->labelsize(11);
        voiceresonanceenabled->callback((Fl_Callback*)cb_voiceresonanceenabled);
        voiceresonanceenabled->align(Fl_Align(FL_ALIGN_LEFT));
        o->value(pars->VoicePar[nvoice].Presonance);
      } // Fl_Check_Button* voiceresonanceenabled
      { mwheel_val_slider_rev* o = voicelfofreq = new mwheel_val_slider_rev(500, 5, 115, 20);
        voicelfofreq->tooltip("Frequency LFO amount");
        voicelfofreq->type(5);
        voicelfofreq->box(FL_THIN_DOWN_BOX);
        voicelfofreq->color(FL_BACKGROUND_COLOR);
        voicelfofreq->selection_color(FL_BACKGROUND_COLOR);
        voicelfofreq->labeltype(FL_NORMAL_LABEL);
        voicelfofreq->labelfont(0);
        voicelfofreq->labelsize(8);
        voicelfofreq->labelcolor(FL_FOREGROUND_COLOR);
        voicelfofreq->maximum(127);
        voicelfofreq->step(1);
        voicelfofreq->callback((Fl_Callback*)cb_voicelfofreq);
        voicelfofreq->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        voicelfofreq->when(FL_WHEN_CHANGED);
        o->value(pars->VoicePar[nvoice].FreqLfo->Pintensity);
      } // mwheel_val_slider_rev* voicelfofreq
      { WidgetPDial* o = voicepanning = new WidgetPDial(215, 5, 20, 20);
        voicepanning->tooltip("Voice panning - zero/leftmost is Random");
        voicepanning->box(FL_ROUND_UP_BOX);
        voicepanning->color(FL_BACKGROUND_COLOR);
        voicepanning->selection_color(FL_INACTIVE_COLOR);
        voicepanning->labeltype(FL_NORMAL_LABEL);
        voicepanning->labelfont(0);
        voicepanning->labelsize(10);
        voicepanning->labelcolor(FL_FOREGROUND_COLOR);
        voicepanning->maximum(127);
        voicepanning->step(1);
        voicepanning->callback((Fl_Callback*)cb_voicepanning);
        voicepanning->align(Fl_Align(FL_ALIGN_LEFT));
        voicepanning->when(FL_WHEN_CHANGED);
        o->value(pars->VoicePar[nvoice].PPanning);
        o->init(64);
      } // WidgetPDial* voicepanning
      { Fl_Group* o = voiceoscil = new Fl_Group(60, 5, 30, 20);
        voiceoscil->box(FL_THIN_DOWN_FRAME);
        voiceoscil->color(FL_GRAY0);
        voiceoscil->selection_color((Fl_Color)71);
        voiceoscil->labelcolor((Fl_Color)179);
        osc = new Oscilloscope(o->x(), o->y(), o->w(), o->h(), "");
        osc->init(pars->VoicePar[nvoice].OscilSmp,0,pars->VoicePar[nvoice].Poscilphase, synth);
        if (pars->VoicePar[nvoice].Pextoscil != -1) {osc->init(pars->VoicePar[pars->VoicePar[nvoice].Pextoscil].OscilSmp, synth);}
        voiceoscil->end();
      } // Fl_Group* voiceoscil
      { noiselabel = new Fl_Box(65, 5, 20, 20, "N");
        noiselabel->labelfont(1);
        noiselabel->labelsize(13);
        noiselabel->labelcolor(FL_BACKGROUND2_COLOR);
        noiselabel->callback((Fl_Callback*)cb_noiselabel);
      } // Fl_Box* noiselabel
      { Fl_Value_Output* o = detunevalueoutput = new Fl_Value_Output(265, 5, 45, 20);
        detunevalueoutput->box(FL_THIN_DOWN_BOX);
        detunevalueoutput->labelsize(10);
        detunevalueoutput->minimum(-5000);
        detunevalueoutput->maximum(5000);
        detunevalueoutput->textfont(1);
        detunevalueoutput->textsize(10);
        detunevalueoutput->callback((Fl_Callback*)cb_detunevalueoutput);
        detunevalueoutput->align(Fl_Align(FL_ALIGN_CENTER));
        o->step(0.01, 1);
        o->value(getDetune(pars->VoicePar[nvoice].PDetuneType, 0, pars->VoicePar[nvoice].PDetune) * pars->getBandwidthDetuneMultiplier());
      } // Fl_Value_Output* detunevalueoutput
      { mwheel_slider_rev* o = voicedetune = new mwheel_slider_rev(310, 5, 185, 20);
        voicedetune->tooltip("Fine Detune (cents)");
        voicedetune->type(5);
        voicedetune->box(FL_THIN_DOWN_BOX);
        voicedetune->color(FL_BACKGROUND_COLOR);
        voicedetune->selection_color(FL_BACKGROUND_COLOR);
        voicedetune->labeltype(FL_NORMAL_LABEL);
        voicedetune->labelfont(0);
        voicedetune->labelsize(14);
        voicedetune->labelcolor(FL_FOREGROUND_COLOR);
        voicedetune->minimum(-8192);
        voicedetune->maximum(8191);
        voicedetune->step(1);
        voicedetune->callback((Fl_Callback*)cb_voicedetune);
        voicedetune->align(Fl_Align(FL_ALIGN_BOTTOM));
        voicedetune->when(FL_WHEN_CHANGED);
        o->value(pars->VoicePar[nvoice].PDetune - 8192);
      } // mwheel_slider_rev* voicedetune
      if (pars->VoicePar[nvoice].Enabled == 0) o->deactivate();
      voicelistitemgroup->end();
    } // Fl_Group* voicelistitemgroup
    { Fl_Check_Button* o = voiceenabled = new Fl_Check_Button(30, 5, 20, 20, "01");
      voiceenabled->down_box(FL_DOWN_BOX);
      voiceenabled->labeltype(FL_EMBOSSED_LABEL);
      voiceenabled->labelfont(1);
      voiceenabled->labelsize(13);
      voiceenabled->callback((Fl_Callback*)cb_voiceenabled);
      voiceenabled->align(Fl_Align(FL_ALIGN_LEFT));
      char tmp[10]; snprintf(tmp, 10, "%d", nvoice + 1); o->label(strdup(tmp));
      o->value(pars->VoicePar[nvoice].Enabled);
    } // Fl_Check_Button* voiceenabled
    ADnoteVoiceListItem->end();
  } // Fl_Group* ADnoteVoiceListItem
  return ADnoteVoiceListItem;
}

ADvoicelistitem::ADvoicelistitem(int x,int y, int w, int h, const char *label):Fl_Group(x,y,w,h,label) {
  nvoice = 0; pars = NULL;
}

void ADvoicelistitem::init(ADnoteParameters *parameters, int npart_, int kititem_, int nvoice_) {
  //
  	synth = parameters->getSynthEngine();
          pars = parameters;
          npart = npart_;
          kititem = kititem_;
          nvoice = nvoice_;
          make_window();
          ADnoteVoiceListItem->show();
          end();
}

void ADvoicelistitem::refreshlist() {
  //
          voiceenabled->value(pars->VoicePar[nvoice].Enabled);
          voiceresonanceenabled->value(pars->VoicePar[nvoice].Presonance);
          voicevolume->value(pars->VoicePar[nvoice].PVolume);
          voicedetune->value(pars->VoicePar[nvoice].PDetune - 8192);
          voicepanning->value(pars->VoicePar[nvoice].PPanning);
          voicelfofreq->value(pars->VoicePar[nvoice].FreqLfo->Pintensity);
          if (pars->VoicePar[nvoice].Pextoscil != -1)
          {
              osc->init(pars->VoicePar[pars->VoicePar[nvoice].Pextoscil].OscilSmp, 0, pars->VoicePar[nvoice].Poscilphase, synth);
          }
          else
              osc->init(pars->VoicePar[nvoice].OscilSmp, 0, pars->VoicePar[nvoice].Poscilphase, synth);
          if (pars->VoicePar[nvoice].Enabled == 0)
              voicelistitemgroup->deactivate();
          else
              voicelistitemgroup->activate();
          detunevalueoutput->do_callback();
          noiselabel->do_callback();
          voicepanning->do_callback();
          ADnoteVoiceListItem->redraw();
}

ADvoicelistitem::~ADvoicelistitem() {
  //
          ADnoteVoiceListItem->hide();
          //delete(ADnoteVoiceListItem);
}

void ADvoiceUI::cb_Enable_i(Fl_Check_Button* o, void*) {
  //
                    pars->VoicePar[nvoice].PFMFreqEnvelopeEnabled = lrint(o->value());
                    if (o->value() == 0)
                        voiceFMfreqenvgroup->deactivate();
                    else
                        voiceFMfreqenvgroup->activate();
                    o->redraw();
                    send_data(104, o->value());
}
void ADvoiceUI::cb_Enable(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Enable_i(o,v);
}

void ADvoiceUI::cb_Coarse_i(Fl_Counter* o, void*) {
  //
                    int k = lrint(o->value());
                    if (k < 0)
                        k += 1024;
                    pars->VoicePar[nvoice].PFMCoarseDetune = k + (pars->VoicePar[nvoice].PFMCoarseDetune / 1024) * 1024;
                    send_data(101, o->value());
}
void ADvoiceUI::cb_Coarse(Fl_Counter* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Coarse_i(o,v);
}

void ADvoiceUI::cb_Octave_i(Fl_Counter* o, void*) {
  //
                    int k = lrint(o->value());
                    if (k < 0)
                        k += 16;
                    pars->VoicePar[nvoice].PFMCoarseDetune = k * 1024 + pars->VoicePar[nvoice].PFMCoarseDetune % 1024;
                    send_data(99, o->value());
}
void ADvoiceUI::cb_Octave(Fl_Counter* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Octave_i(o,v);
}

void ADvoiceUI::cb_fmdetunevalueoutput_i(Fl_Value_Output* o, void*) {
  o->value(getDetune((pars->VoicePar[nvoice].PFMDetuneType == 0) ? (pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PFMDetuneType), 0, pars->VoicePar[nvoice].PFMDetune));
}
void ADvoiceUI::cb_fmdetunevalueoutput(Fl_Value_Output* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_fmdetunevalueoutput_i(o,v);
}

void ADvoiceUI::cb__i(mwheel_slider_rev* o, void*) {
  //
                    if (Fl::event_button() == 3)
    			o->value(0);
                    pars->VoicePar[nvoice].PFMDetune = (int)o->value() + 8192;
                    fmdetunevalueoutput->do_callback();
                    send_data(96, o->value());
}
void ADvoiceUI::cb_(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb__i(o,v);
}

void ADvoiceUI::cb_Detune_i(Fl_Choice* o, void*) {
  //
                    pars->VoicePar[nvoice].PFMDetuneType = lrint(o->value());
                    fmdetunevalueoutput->do_callback();
                    send_data(100, o->value());
}
void ADvoiceUI::cb_Detune(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Detune_i(o,v);
}

void ADvoiceUI::cb_Mod440_i(Fl_Check_Button* o, void*) {
  pars->VoicePar[nvoice].PFMFixedFreq = o->value();
if (o->value() == 0 && lrint(Freq440->value() == 0))
    fixedfreqetdial->deactivate();
else
    fixedfreqetdial->activate();
}
void ADvoiceUI::cb_Mod440(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Mod440_i(o,v);
}

void ADvoiceUI::cb_Vol_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
    o->value(90);
pars->VoicePar[nvoice].PFMVolume = lrint(o->value());
send_data(80, o->value());
}
void ADvoiceUI::cb_Vol(mwheel_val_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Vol_i(o,v);
}

void ADvoiceUI::cb_V_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
    o->value(64);
pars->VoicePar[nvoice].PFMVelocityScaleFunction = lrint(o->value());
send_data(81, o->value());
}
void ADvoiceUI::cb_V(mwheel_val_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_V_i(o,v);
}

void ADvoiceUI::cb_Enable1_i(Fl_Check_Button* o, void*) {
  //
                    pars->VoicePar[nvoice].PFMAmpEnvelopeEnabled = lrint(o->value());
                    if (o->value() == 0)
                        voiceFMampenvgroup->deactivate();
                    else
                        voiceFMampenvgroup->activate();
                    o->redraw();
                    send_data(88, o->value());
}
void ADvoiceUI::cb_Enable1(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Enable1_i(o,v);
}

void ADvoiceUI::cb_F_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
    o->value(0);
pars->VoicePar[nvoice].PFMVolumeDamp = lrint(o->value()) + 64;

send_data(82, o->value());
}
void ADvoiceUI::cb_F(mwheel_val_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_F_i(o,v);
}

void ADvoiceUI::cb_changeFMoscilbutton_i(Fl_Button*, void*) {
  //
                    if (oscedit != NULL)
                        delete oscedit;
                    int nv = nvoice;
                    if (pars->VoicePar[nvoice].PextFMoscil >= 0)
                        nv = pars->VoicePar[nvoice].PextFMoscil;
                    oscedit = new OscilEditor(pars->VoicePar[nv].FMSmp, fmoscil, NULL, NULL, synth, npart, kititem, nvoice + 0xC0);
                    if ((Fl::event_button() == 3))
        		synth->getGuiMaster()->partui->adnoteui->ADnoteVoice->hide();
}
void ADvoiceUI::cb_changeFMoscilbutton(Fl_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_changeFMoscilbutton_i(o,v);
}

void ADvoiceUI::cb_Phase_i(mwheel_slider_rev* o, void*) {
  //
                    if (Fl::event_button() == 3)
   			 o->value(0);
                    pars->VoicePar[nvoice].PFMoscilphase = 64 - lrint(o->value());
                    oscFM->phase = 64 - lrint(o->value());
                    fmoscil->redraw();

                    send_data(112, o->value());
}
void ADvoiceUI::cb_Phase(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Phase_i(o,v);
}

void ADvoiceUI::cb_Use_i(Fl_Choice* o, void*) {
  //
                    pars->VoicePar[nvoice].PextFMoscil = lrint(o->value()) - 1;
                    if (lrint(o->value()))
                    {
                        oscFM->init(pars->VoicePar[lrint(o->value()) - 1].FMSmp, synth);
                        changeFMoscilbutton->labelcolor(FL_BLUE);
                    }
                    else
                    {
                        oscFM->init(pars->VoicePar[nvoice].FMSmp, synth);
                        changeFMoscilbutton->labelcolor(FL_BLACK);
                    }
                    voiceFMparametersgroup->redraw();
                    send_data(113, o->value());
}
void ADvoiceUI::cb_Use(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Use_i(o,v);
}

void ADvoiceUI::cb_External_i(Fl_Choice* o, void*) {
  //
                  pars->VoicePar[nvoice].PFMVoice = lrint(o->value()) - 1;
                  if (lrint(o->value()))
                  {
                      modoscil->deactivate();
                      modfrequency->deactivate();
                  }
                  else
                  {
                      modoscil->activate();
                      modfrequency->activate();
                  }
                  voiceFMparametersgroup->redraw();
                  send_data(17, o->value());
}
void ADvoiceUI::cb_External(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_External_i(o,v);
}

void ADvoiceUI::cb_Type_i(Fl_Choice* o, void*) {
  //
                pars->VoicePar[nvoice].PFMEnabled = lrint(o->value());
                if (o->value() == 0)
                    voiceFMparametersgroup->deactivate();
                else
                    voiceFMparametersgroup->activate();
                o->redraw();
                send_data(16, o->value());
}
void ADvoiceUI::cb_Type(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Type_i(o,v);
}

Fl_Menu_Item ADvoiceUI::menu_Type[] = {
 {"OFF", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"MORPH", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"RING", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"PM", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"FM", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"PWM", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ADvoiceUI::cb_Enable2_i(Fl_Check_Button* o, void*) {
  //
                  pars->VoicePar[nvoice].PFreqEnvelopeEnabled = lrint(o->value());
                  if (o->value() == 0)
                      voicefreqenvgroup->deactivate();
                  else
                      voicefreqenvgroup->activate();
                  o->redraw();
                  send_data(40, o->value());
}
void ADvoiceUI::cb_Enable2(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Enable2_i(o,v);
}

void ADvoiceUI::cb_Enable3_i(Fl_Check_Button* o, void*) {
  //
                  pars->VoicePar[nvoice].PFreqLfoEnabled = lrint(o->value());
                  if (o->value() == 0)
                      voicefreqlfogroup->deactivate();
                  else
                      voicefreqlfogroup->activate();
                  o->redraw();
                  send_data(41, o->value());
}
void ADvoiceUI::cb_Enable3(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Enable3_i(o,v);
}

void ADvoiceUI::cb_Octave1_i(Fl_Counter* o, void*) {
  //
                  int k = lrint(o->value());
                  if (k < 0)
                      k += 16;
                  pars->VoicePar[nvoice].PCoarseDetune = k * 1024 + pars->VoicePar[nvoice].PCoarseDetune % 1024;
                  send_data(35, o->value());
}
void ADvoiceUI::cb_Octave1(Fl_Counter* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Octave1_i(o,v);
}

void ADvoiceUI::cb_Coarse1_i(Fl_Counter* o, void*) {
  //
                  int k = lrint(o->value());
                  if (k < 0)
                      k += 1024;
                  pars->VoicePar[nvoice].PCoarseDetune = k + (pars->VoicePar[nvoice].PCoarseDetune / 1024) * 1024;
                  send_data(37, o->value());
}
void ADvoiceUI::cb_Coarse1(Fl_Counter* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Coarse1_i(o,v);
}

void ADvoiceUI::cb_detunevalueoutput1_i(Fl_Value_Output* o, void*) {
  o->value(getDetune((pars->VoicePar[nvoice].PDetuneType==0)?(pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PDetuneType),0,pars->VoicePar[nvoice].PDetune)*pars->getBandwidthDetuneMultiplier());
}
void ADvoiceUI::cb_detunevalueoutput1(Fl_Value_Output* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_detunevalueoutput1_i(o,v);
}

void ADvoiceUI::cb_1_i(mwheel_slider_rev* o, void*) {
  //
                  if (Fl::event_button() == 3)
   			 o->value(0);
                  pars->VoicePar[nvoice].PDetune = lrint(o->value()) + 8192;
                  detunevalueoutput->do_callback();

                  send_data(32, o->value());
}
void ADvoiceUI::cb_1(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_1_i(o,v);
}

void ADvoiceUI::cb_Freq440_i(Fl_Check_Button* o, void*) {
  //
                  int x = lrint(o->value());
                  pars->VoicePar[nvoice].Pfixedfreq = x;
                  if (x == 0 && Mod440->value() == 0)
                      fixedfreqetdial->deactivate();
                  else
                      fixedfreqetdial->activate();
                  send_data(34, o->value());
}
void ADvoiceUI::cb_Freq440(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Freq440_i(o,v);
}

void ADvoiceUI::cb_fixedfreqetdial_i(WidgetPDial* o, void*) {
  pars->VoicePar[nvoice].PfixedfreqET = lrint(o->value());
send_data(33, o->value());
}
void ADvoiceUI::cb_fixedfreqetdial(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_fixedfreqetdial_i(o,v);
}

void ADvoiceUI::cb_Detune1_i(Fl_Choice* o, void*) {
  pars->VoicePar[nvoice].PDetuneType = lrint(o->value()); detunevalueoutput->do_callback();
send_data(36, o->value());
}
void ADvoiceUI::cb_Detune1(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Detune1_i(o,v);
}

void ADvoiceUI::cb_bend_i(WidgetPDial* o, void*) {
  pars->VoicePar[nvoice].PBendAdjust = lrint(o->value());
send_data(38, o->value());
}
void ADvoiceUI::cb_bend(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_bend_i(o,v);
}

void ADvoiceUI::cb_offset_i(WidgetPDial* o, void*) {
  pars->VoicePar[nvoice].POffsetHz = lrint(o->value());
send_data(39, o->value());
}
void ADvoiceUI::cb_offset(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_offset_i(o,v);
}

void ADvoiceUI::cb_changevoiceoscilbutton_i(Fl_Button*, void*) {
  //
    if (oscedit)
        delete oscedit;
    int nv = nvoice;
    if (pars->VoicePar[nvoice].Pextoscil >= 0)
        nv=pars->VoicePar[nvoice].Pextoscil;
    oscedit = new OscilEditor(pars->VoicePar[nv].OscilSmp, voiceoscil, NULL, NULL, synth, npart, kititem, nvoice + 0x80);
    if ((Fl::event_button() == 3))
        synth->getGuiMaster()->partui->adnoteui->ADnoteVoice->hide();
}
void ADvoiceUI::cb_changevoiceoscilbutton(Fl_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_changevoiceoscilbutton_i(o,v);
}

void ADvoiceUI::cb_Phase1_i(mwheel_slider_rev* o, void*) {
  //
                if (Fl::event_button() == 3)
    			o->value(0);
                pars->VoicePar[nvoice].Poscilphase =64 - lrint(o->value());
                osc->phase = 64 - lrint(o->value());
                voiceoscil->redraw();

                send_data(136, o->value());
}
void ADvoiceUI::cb_Phase1(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Phase1_i(o,v);
}

void ADvoiceUI::cb_Reson_i(Fl_Check_Button* o, void*) {
  pars->VoicePar[nvoice].Presonance = lrint(o->value());
send_data(130, o->value());
}
void ADvoiceUI::cb_Reson(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Reson_i(o,v);
}

void ADvoiceUI::cb_Use1_i(Fl_Choice* o, void*) {
  //
                pars->VoicePar[nvoice].Pextoscil = lrint(o->value()) - 1;
                if (lrint(o->value())) {
                    osc->init(pars->VoicePar[lrint(o->value()) - 1].OscilSmp, synth);
                    changevoiceoscilbutton->labelcolor(FL_BLUE);
                }
                else
                {
                    osc->init(pars->VoicePar[nvoice].OscilSmp, synth);
                    changevoiceoscilbutton->labelcolor(FL_BLACK);
                }

                voiceparametersgroup->redraw();
                voiceonbutton->redraw();
                send_data(137, o->value());
}
void ADvoiceUI::cb_Use1(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Use1_i(o,v);
}

void ADvoiceUI::cb_Unison_i(Fl_Check_Button* o, void*) {
  int colr = FL_BLACK;
if (o->value() == 0)
{
  pars->VoicePar[nvoice].Unison_size = lrint(o->value());
  unisonsize->value(2);
  unisongroup->deactivate();
}
else
{
  int tmp = lrint(unisonsize->value());
  pars->VoicePar[nvoice].Unison_size = tmp;
  unisongroup->activate();
  int i = -1;
  while(true)
  {
    i++;
    if (pars->ADnote_unison_sizes[i] == 0)
      break;
    if (pars->ADnote_unison_sizes[i] == tmp)
    {
      colr = FL_RED;
      break;
    }
  }
}
unisonsize->labelcolor(colr);
send_data(56, o->value());
}
void ADvoiceUI::cb_Unison(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Unison_i(o,v);
}

void ADvoiceUI::cb_unisonsize_i(Fl_Spinner* o, void*) {
  int tmp = lrint(o->value());
pars->VoicePar[nvoice].Unison_size = tmp;
int colr = FL_BLACK;
int i = -1;
while(true)
{
  i++;
  if (pars->ADnote_unison_sizes[i] == 0)
    break;
  if (pars->ADnote_unison_sizes[i] == tmp)
  {
   colr = FL_RED;
    break;
  }
}
o->labelcolor(colr);
unisongroup->redraw();
send_data(53, o->value());
}
void ADvoiceUI::cb_unisonsize(Fl_Spinner* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_unisonsize_i(o,v);
}

void ADvoiceUI::cb_Stereo_i(WidgetPDial* o, void*) {
  pars->VoicePar[nvoice].Unison_stereo_spread = lrint(o->value());
send_data(50, o->value());
}
void ADvoiceUI::cb_Stereo(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Stereo_i(o,v);
}

void ADvoiceUI::cb_Vib_i(WidgetPDial* o, void*) {
  pars->VoicePar[nvoice].Unison_vibratto = lrint(o->value());
send_data(51, o->value());
}
void ADvoiceUI::cb_Vib(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Vib_i(o,v);
}

void ADvoiceUI::cb_Invert_i(Fl_Choice* o, void*) {
  pars->VoicePar[nvoice].Unison_invert_phase = lrint(o->value());
send_data(54, o->value());
}
void ADvoiceUI::cb_Invert(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Invert_i(o,v);
}

void ADvoiceUI::cb_Frequency_i(mwheel_slider_rev* o, void*) {
  //
                  if (Fl::event_button() == 3)
                      o->value(60);
                  pars->VoicePar[nvoice].Unison_frequency_spread = lrint(o->value());
                  unisonspreadoutput->do_callback();
                  send_data(48, o->value());
}
void ADvoiceUI::cb_Frequency(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Frequency_i(o,v);
}

void ADvoiceUI::cb_unisonspreadoutput_i(Fl_Value_Output* o, void*) {
  o->value(pars->getUnisonFrequencySpreadCents(nvoice));
}
void ADvoiceUI::cb_unisonspreadoutput(Fl_Value_Output* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_unisonspreadoutput_i(o,v);
}

void ADvoiceUI::cb_V1_i(WidgetPDial* o, void*) {
  pars->VoicePar[nvoice].Unison_vibratto_speed = lrint(o->value());
send_data(52, o->value());
}
void ADvoiceUI::cb_V1(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_V1_i(o,v);
}

void ADvoiceUI::cb_Ph_i(WidgetPDial* o, void*) {
  pars->VoicePar[nvoice].Unison_phase_randomness=lrint(o->value());
send_data(49, o->value());
}
void ADvoiceUI::cb_Ph(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Ph_i(o,v);
}

void ADvoiceUI::cb_voicevolume1_i(WidgetPDial* o, void*) {
  pars->VoicePar[nvoice].PVolume = lrint(o->value());
send_data(0, o->value());
}
void ADvoiceUI::cb_voicevolume1(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_voicevolume1_i(o,v);
}

void ADvoiceUI::cb_Vel_i(WidgetPDial* o, void*) {
  pars->VoicePar[nvoice].PAmpVelocityScaleFunction = lrint(o->value());
send_data(1, o->value());
}
void ADvoiceUI::cb_Vel(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Vel_i(o,v);
}

void ADvoiceUI::cb_voicepan_i(WidgetPDial* o, void*) {
  //
                 pars->setVoicePan(nvoice, lrint(o->value()));
                 voicerandompan->value(pars->randomVoicePan(nvoice));
                 send_data(2, o->value());
}
void ADvoiceUI::cb_voicepan(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_voicepan_i(o,v);
}

void ADvoiceUI::cb_voicerandompan_i(Fl_Light_Button* o, void*) {
  //
                if(pars->randomVoicePan(nvoice))
                {
                    voicepan->value(64);
                    pars->setVoicePan(nvoice, 64);
                }
                o->value(pars->randomVoicePan(nvoice));
}
void ADvoiceUI::cb_voicerandompan(Fl_Light_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_voicerandompan_i(o,v);
}

void ADvoiceUI::cb_Enable4_i(Fl_Check_Button* o, void*) {
  //
                pars->VoicePar[nvoice].PAmpEnvelopeEnabled = lrint(o->value());
                if (o->value() == 0)
                    voiceampenvgroup->deactivate();
                else
                    voiceampenvgroup->activate();
                o->redraw();
                send_data(8, o->value());
}
void ADvoiceUI::cb_Enable4(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Enable4_i(o,v);
}

void ADvoiceUI::cb_Enable5_i(Fl_Check_Button* o, void*) {
  //
                pars->VoicePar[nvoice].PAmpLfoEnabled = lrint(o->value());
                if (o->value() == 0)
                    voiceamplfogroup->deactivate();
                else
                    voiceamplfogroup->activate();
                o->redraw();
                send_data(9, o->value());
}
void ADvoiceUI::cb_Enable5(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Enable5_i(o,v);
}

void ADvoiceUI::cb_Minus_i(Fl_Check_Button* o, void*) {
  pars->VoicePar[nvoice].PVolumeminus = lrint(o->value());
send_data(4, o->value());
}
void ADvoiceUI::cb_Minus(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Minus_i(o,v);
}

void ADvoiceUI::cb_Enable6_i(Fl_Check_Button* o, void*) {
  //
                pars->VoicePar[nvoice].PFilterEnvelopeEnabled = lrint(o->value());
                if (o->value() == 0)
                    voicefilterenvgroup->deactivate();
                else
                    voicefilterenvgroup->activate();
                o->redraw();
                send_data(72, o->value());
}
void ADvoiceUI::cb_Enable6(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Enable6_i(o,v);
}

void ADvoiceUI::cb_Enable7_i(Fl_Check_Button* o, void*) {
  //
                pars->VoicePar[nvoice].PFilterLfoEnabled = lrint(o->value());
                if (o->value() == 0)
                    voicefilterlfogroup->deactivate();
                else
                    voicefilterlfogroup->activate();
                o->redraw();
                send_data(73, o->value());
}
void ADvoiceUI::cb_Enable7(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Enable7_i(o,v);
}

void ADvoiceUI::cb_2_i(Fl_Choice* o, void*) {
  int x = lrint(o->value());
              pars->VoicePar[nvoice].Type = x;
              if (!x)
              {
                  voicemodegroup->activate();
              }
              else
                  voicemodegroup->deactivate();
              noiselabel->do_callback();
              send_data(138, o->value());
}
void ADvoiceUI::cb_2(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->user_data()))->cb_2_i(o,v);
}

Fl_Menu_Item ADvoiceUI::menu_[] = {
 {"Sound", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 2},
 {"Noise", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 0},
 {"Noise", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 5},
 {0,0,0,0,0,0,0,0,0}
};

void ADvoiceUI::cb_Delay_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
    o->value(0);
pars->VoicePar[nvoice].PDelay = lrint(o->value());

send_data(128, o->value());
}
void ADvoiceUI::cb_Delay(mwheel_val_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Delay_i(o,v);
}

void ADvoiceUI::cb_bypassfiltercheckbutton_i(Fl_Check_Button* o, void*) {
  pars->VoicePar[nvoice].Pfilterbypass = lrint(o->value());
send_data(64, o->value());
}
void ADvoiceUI::cb_bypassfiltercheckbutton(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->user_data()))->cb_bypassfiltercheckbutton_i(o,v);
}

void ADvoiceUI::cb_Enable8_i(Fl_Check_Button* o, void*) {
  //
              pars->VoicePar[nvoice].PFilterEnabled = lrint(o->value());
              if (o->value() == 0)
                  voicefiltergroup->deactivate();
              else
                  voicefiltergroup->activate();
              o->redraw();
              bypassfiltercheckbutton->redraw();
              send_data(68, o->value());
}
void ADvoiceUI::cb_Enable8(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->user_data()))->cb_Enable8_i(o,v);
}

void ADvoiceUI::cb_noiselabel1_i(Fl_Box* o, void*) {
  o->hide();
switch (pars->VoicePar[nvoice].Type)
{
    case 0:
        return;
        break;
    case 1:
        o->copy_label("White Noise");
        o->labelcolor(7);
        break;
    default:
        o->copy_label("Pink Noise");
        o->labelcolor(5);
        break;
}
o->show();
}
void ADvoiceUI::cb_noiselabel1(Fl_Box* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->user_data()))->cb_noiselabel1_i(o,v);
}

void ADvoiceUI::cb_voiceonbutton_i(Fl_Check_Button* o, void*) {
  //
            pars->VoicePar[nvoice].Enabled = lrint(o->value());
            if (o->value() == 0)
                voiceparametersgroup->deactivate();
            else
                voiceparametersgroup->activate();
            o->redraw();
            send_data(129, o->value());
}
void ADvoiceUI::cb_voiceonbutton(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->user_data()))->cb_voiceonbutton_i(o,v);
}

Fl_Group* ADvoiceUI::make_window() {
  { Fl_Group* o = ADnoteVoiceParameters = new Fl_Group(0, 0, 770, 580, "Voice");
    ADnoteVoiceParameters->box(FL_FLAT_BOX);
    ADnoteVoiceParameters->color(FL_BACKGROUND_COLOR);
    ADnoteVoiceParameters->selection_color(FL_BACKGROUND_COLOR);
    ADnoteVoiceParameters->labeltype(FL_NO_LABEL);
    ADnoteVoiceParameters->labelfont(0);
    ADnoteVoiceParameters->labelsize(14);
    ADnoteVoiceParameters->labelcolor(FL_FOREGROUND_COLOR);
    ADnoteVoiceParameters->user_data((void*)(this));
    ADnoteVoiceParameters->align(Fl_Align(FL_ALIGN_TOP));
    ADnoteVoiceParameters->when(FL_WHEN_RELEASE);
    { Fl_Group* o = voiceparametersgroup = new Fl_Group(0, 0, 765, 580);
      voiceparametersgroup->box(FL_THIN_UP_BOX);
      voiceparametersgroup->color((Fl_Color)48);
      { voicemodegroup = new Fl_Group(0, 5, 760, 575);
        { Fl_Group* o = voiceFMparametersgroup = new Fl_Group(530, 5, 230, 565, "MODULATOR");
          voiceFMparametersgroup->box(FL_THIN_UP_FRAME);
          voiceFMparametersgroup->color((Fl_Color)48);
          voiceFMparametersgroup->labelfont(1);
          voiceFMparametersgroup->labelsize(11);
          voiceFMparametersgroup->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
          { modfrequency = new Fl_Group(535, 204, 220, 161, "Mod FREQUENCY");
            modfrequency->box(FL_THIN_UP_BOX);
            modfrequency->labelfont(1);
            modfrequency->labelsize(11);
            modfrequency->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
            { EnvelopeUI* o = voiceFMfreqenvgroup = new EnvelopeUI(540, 290, 205, 70, "ADSynth Modulator - Frequency Envelope");
              voiceFMfreqenvgroup->box(FL_FLAT_BOX);
              voiceFMfreqenvgroup->color((Fl_Color)51);
              voiceFMfreqenvgroup->selection_color(FL_BACKGROUND_COLOR);
              voiceFMfreqenvgroup->labeltype(FL_NORMAL_LABEL);
              voiceFMfreqenvgroup->labelfont(0);
              voiceFMfreqenvgroup->labelsize(14);
              voiceFMfreqenvgroup->labelcolor(FL_FOREGROUND_COLOR);
              voiceFMfreqenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
              voiceFMfreqenvgroup->when(FL_WHEN_RELEASE);
              o->init(pars->VoicePar[nvoice].FMFreqEnvelope, npart, kititem, nvoice | 0xc0, 1);
              if (pars->VoicePar[nvoice].PFMFreqEnvelopeEnabled==0) o->deactivate();
              voiceFMfreqenvgroup->end();
            } // EnvelopeUI* voiceFMfreqenvgroup
            { Fl_Check_Button* o = new Fl_Check_Button(545, 295, 50, 10, "Enable");
              o->tooltip("Forced Relase");
              o->down_box(FL_DOWN_BOX);
              o->labelfont(1);
              o->labelsize(10);
              o->callback((Fl_Callback*)cb_Enable);
              o->value(pars->VoicePar[nvoice].PFMFreqEnvelopeEnabled);
            } // Fl_Check_Button* o
            { Fl_Counter* o = new Fl_Counter(685, 270, 60, 15, "Coarse Det.");
              o->tooltip("Coarse Detune");
              o->labelsize(10);
              o->minimum(-64);
              o->maximum(63);
              o->step(1);
              o->textfont(1);
              o->textsize(11);
              o->callback((Fl_Callback*)cb_Coarse);
              o->align(Fl_Align(FL_ALIGN_TOP));
              int k = pars->VoicePar[nvoice].PFMCoarseDetune % 1024;
              if (k >= 512) k-= 1024;
              o->value(k);
              o->lstep(10);
            } // Fl_Counter* o
            { Fl_Counter* o = new Fl_Counter(625, 270, 45, 15, "Octave");
              o->tooltip("Octave");
              o->type(1);
              o->labelsize(10);
              o->minimum(-8);
              o->maximum(7);
              o->step(1);
              o->textfont(1);
              o->textsize(11);
              o->callback((Fl_Callback*)cb_Octave);
              o->align(Fl_Align(FL_ALIGN_TOP));
              int k = pars->VoicePar[nvoice].PFMCoarseDetune / 1024;
              if (k >= 8) k -= 16;
              o->value(k);
            } // Fl_Counter* o
            { Fl_Value_Output* o = fmdetunevalueoutput = new Fl_Value_Output(542, 224, 36, 16, "Detune");
              fmdetunevalueoutput->box(FL_THIN_DOWN_BOX);
              fmdetunevalueoutput->labelsize(8);
              fmdetunevalueoutput->minimum(-5000);
              fmdetunevalueoutput->maximum(5000);
              fmdetunevalueoutput->textfont(1);
              fmdetunevalueoutput->textsize(8);
              fmdetunevalueoutput->callback((Fl_Callback*)cb_fmdetunevalueoutput);
              fmdetunevalueoutput->align(Fl_Align(FL_ALIGN_TOP_LEFT));
              o->step(0.01, 1);
              o->value(getDetune((pars->VoicePar[nvoice].PFMDetuneType == 0) ? (pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PFMDetuneType), 0, pars->VoicePar[nvoice].PFMDetune));
            } // Fl_Value_Output* fmdetunevalueoutput
            { mwheel_slider_rev* o = new mwheel_slider_rev(578, 224, 168, 16);
              o->tooltip("Fine Detune (cents)");
              o->type(5);
              o->box(FL_THIN_DOWN_BOX);
              o->color(FL_BACKGROUND_COLOR);
              o->selection_color(FL_BACKGROUND_COLOR);
              o->labeltype(FL_NORMAL_LABEL);
              o->labelfont(0);
              o->labelsize(14);
              o->labelcolor(FL_FOREGROUND_COLOR);
              o->minimum(-8192);
              o->maximum(8191);
              o->step(1);
              o->callback((Fl_Callback*)cb_);
              o->align(Fl_Align(FL_ALIGN_BOTTOM));
              o->when(FL_WHEN_CHANGED);
              o->value(pars->VoicePar[nvoice].PFMDetune-8192);
            } // mwheel_slider_rev* o
            { Fl_Choice* o = new Fl_Choice(540, 270, 75, 15, "Detune Type");
              o->down_box(FL_BORDER_BOX);
              o->labelsize(10);
              o->textfont(1);
              o->textsize(10);
              o->callback((Fl_Callback*)cb_Detune);
              o->align(Fl_Align(FL_ALIGN_TOP_LEFT));
              //
                    o->add("Default");
                    o->add("L35cents");
                    o->add("L10cents");
                    o->add("E100cents");
                    o->add("E1200cents");
              o->value(pars->VoicePar[nvoice].PFMDetuneType);
            } // Fl_Choice* o
            { Fl_Check_Button* o = Mod440 = new Fl_Check_Button(683, 242, 55, 15, "440Hz");
              Mod440->tooltip("Set the modulator base frequency to 440Hz");
              Mod440->down_box(FL_DOWN_BOX);
              Mod440->labelfont(1);
              Mod440->labelsize(11);
              Mod440->callback((Fl_Callback*)cb_Mod440);
              o->value(pars->VoicePar[nvoice].PFMFixedFreq);
            } // Fl_Check_Button* Mod440
            modfrequency->end();
          } // Fl_Group* modfrequency
          { Fl_Group* o = new Fl_Group(535, 55, 220, 149, "Mod AMPLITUDE");
            o->box(FL_THIN_UP_BOX);
            o->labelfont(1);
            o->labelsize(11);
            o->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
            { mwheel_val_slider_rev* o = new mwheel_val_slider_rev(540, 70, 160, 15, "Vol");
              o->tooltip("Volume");
              o->type(5);
              o->box(FL_THIN_DOWN_BOX);
              o->color(FL_BACKGROUND_COLOR);
              o->selection_color(FL_BACKGROUND_COLOR);
              o->labeltype(FL_NORMAL_LABEL);
              o->labelfont(0);
              o->labelsize(11);
              o->labelcolor(FL_FOREGROUND_COLOR);
              o->maximum(127);
              o->step(1);
              o->callback((Fl_Callback*)cb_Vol);
              o->align(Fl_Align(FL_ALIGN_RIGHT));
              o->when(FL_WHEN_CHANGED);
              o->value(pars->VoicePar[nvoice].PFMVolume);
            } // mwheel_val_slider_rev* o
            { mwheel_val_slider_rev* o = new mwheel_val_slider_rev(540, 90, 160, 15, "V.Sns");
              o->tooltip("Velocity Sensing Function - rightmost/max to disable)");
              o->type(5);
              o->box(FL_THIN_DOWN_BOX);
              o->color(FL_BACKGROUND_COLOR);
              o->selection_color(FL_BACKGROUND_COLOR);
              o->labeltype(FL_NORMAL_LABEL);
              o->labelfont(0);
              o->labelsize(11);
              o->labelcolor(FL_FOREGROUND_COLOR);
              o->maximum(127);
              o->step(1);
              o->callback((Fl_Callback*)cb_V);
              o->align(Fl_Align(FL_ALIGN_RIGHT));
              o->when(FL_WHEN_CHANGED);
              o->value(pars->VoicePar[nvoice].PFMVelocityScaleFunction);
            } // mwheel_val_slider_rev* o
            { EnvelopeUI* o = voiceFMampenvgroup = new EnvelopeUI(542, 129, 205, 70, "ADSynth Modulator - Amplitude Envelope");
              voiceFMampenvgroup->box(FL_FLAT_BOX);
              voiceFMampenvgroup->color((Fl_Color)51);
              voiceFMampenvgroup->selection_color(FL_BACKGROUND_COLOR);
              voiceFMampenvgroup->labeltype(FL_NORMAL_LABEL);
              voiceFMampenvgroup->labelfont(0);
              voiceFMampenvgroup->labelsize(14);
              voiceFMampenvgroup->labelcolor(FL_FOREGROUND_COLOR);
              voiceFMampenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
              voiceFMampenvgroup->when(FL_WHEN_RELEASE);
              o->init(pars->VoicePar[nvoice].FMAmpEnvelope, npart, kititem, nvoice | 0xc0, 0);
              if (pars->VoicePar[nvoice].PFMAmpEnvelopeEnabled==0) o->deactivate();
              voiceFMampenvgroup->end();
            } // EnvelopeUI* voiceFMampenvgroup
            { Fl_Check_Button* o = new Fl_Check_Button(546, 134, 50, 10, "Enable");
              o->tooltip("Forced Relase");
              o->down_box(FL_DOWN_BOX);
              o->labelfont(1);
              o->labelsize(10);
              o->callback((Fl_Callback*)cb_Enable1);
              o->value(pars->VoicePar[nvoice].PFMAmpEnvelopeEnabled);
            } // Fl_Check_Button* o
            { mwheel_val_slider_rev* o = new mwheel_val_slider_rev(540, 110, 160, 15, "F.Damp");
              o->tooltip("Modulator Damp at Higher frequency");
              o->type(5);
              o->box(FL_THIN_DOWN_BOX);
              o->color(FL_BACKGROUND_COLOR);
              o->selection_color(FL_BACKGROUND_COLOR);
              o->labeltype(FL_NORMAL_LABEL);
              o->labelfont(0);
              o->labelsize(11);
              o->labelcolor(FL_FOREGROUND_COLOR);
              o->minimum(-64);
              o->maximum(63);
              o->step(1);
              o->callback((Fl_Callback*)cb_F);
              o->align(Fl_Align(FL_ALIGN_RIGHT));
              o->when(FL_WHEN_CHANGED);
              o->value(pars->VoicePar[nvoice].PFMVolumeDamp-64);
            } // mwheel_val_slider_rev* o
            o->end();
          } // Fl_Group* o
          { modoscil = new Fl_Group(535, 365, 220, 200, "Mod Oscilator");
            modoscil->box(FL_THIN_UP_BOX);
            modoscil->labelfont(1);
            modoscil->labelsize(12);
            modoscil->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
            { Fl_Group* o = fmoscil = new Fl_Group(535, 425, 220, 140);
              fmoscil->box(FL_THIN_DOWN_BOX);
              fmoscil->color(FL_GRAY0);
              fmoscil->selection_color((Fl_Color)71);
              fmoscil->labelcolor((Fl_Color)179);
              oscFM = new Oscilloscope(o->x(),o->y(),o->w(),o->h(),"");
              int nv=nvoice; if (pars->VoicePar[nvoice].PextFMoscil>=0) nv=pars->VoicePar[nvoice].PextFMoscil;
              oscFM->init(pars->VoicePar[nv].FMSmp,0,pars->VoicePar[nvoice].PFMoscilphase, synth);
              fmoscil->end();
            } // Fl_Group* fmoscil
            { Fl_Box* o = new Fl_Box(535, 365, 155, 20, "Mod.Oscillator");
              o->labelfont(1);
              o->labelsize(12);
              o->align(Fl_Align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE));
              o->hide();
              o->deactivate();
            } // Fl_Box* o
            { Fl_Button* o = changeFMoscilbutton = new Fl_Button(704, 368, 43, 12, "Change");
              changeFMoscilbutton->box(FL_THIN_UP_BOX);
              changeFMoscilbutton->labelfont(1);
              changeFMoscilbutton->labelsize(9);
              changeFMoscilbutton->callback((Fl_Callback*)cb_changeFMoscilbutton);
              if (pars->VoicePar[nvoice].PextFMoscil>=0) o->labelcolor(FL_BLUE);
            } // Fl_Button* changeFMoscilbutton
            { mwheel_slider_rev* o = new mwheel_slider_rev(665, 396, 65, 12, "Phase");
              o->type(5);
              o->box(FL_THIN_DOWN_BOX);
              o->color(FL_BACKGROUND_COLOR);
              o->selection_color(FL_BACKGROUND_COLOR);
              o->labeltype(FL_NORMAL_LABEL);
              o->labelfont(0);
              o->labelsize(10);
              o->labelcolor(FL_FOREGROUND_COLOR);
              o->minimum(-64);
              o->maximum(63);
              o->step(1);
              o->callback((Fl_Callback*)cb_Phase);
              o->align(Fl_Align(FL_ALIGN_TOP));
              o->when(FL_WHEN_CHANGED);
              o->value(64-pars->VoicePar[nvoice].PFMoscilphase);
            } // mwheel_slider_rev* o
            { Fl_Choice* o = new Fl_Choice(560, 395, 75, 15, "Use");
              o->down_box(FL_BORDER_BOX);
              o->labelsize(10);
              o->textfont(1);
              o->textsize(10);
              o->callback((Fl_Callback*)cb_Use);
              o->add("Internal");
              char tmp[50]; for (int i = 0; i < nvoice; ++i) {sprintf(tmp, "ExtM.%2d", i + 1); o->add(tmp);};
              o->value(pars->VoicePar[nvoice].PextFMoscil + 1);
            } // Fl_Choice* o
            modoscil->end();
          } // Fl_Group* modoscil
          { Fl_Choice* o = new Fl_Choice(635, 32, 85, 20, "External Mod.");
            o->down_box(FL_BORDER_BOX);
            o->labelsize(10);
            o->textfont(1);
            o->textsize(10);
            o->callback((Fl_Callback*)cb_External);
            o->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->add("OFF");
            char tmp[50]; for (int i = 0; i < nvoice; ++i) {sprintf(tmp, "ExtMod.%2d", i + 1); o->add(tmp);};
            o->value(pars->VoicePar[nvoice].PFMVoice + 1);
            if (lrint(o->value())) {modoscil->deactivate(); modfrequency->deactivate();}
          } // Fl_Choice* o
          if (pars->VoicePar[nvoice].PFMEnabled==0) o->deactivate();
          voiceFMparametersgroup->end();
        } // Fl_Group* voiceFMparametersgroup
        { Fl_Choice* o = new Fl_Choice(535, 32, 80, 20, "Type:");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(11);
          o->textsize(11);
          o->callback((Fl_Callback*)cb_Type);
          o->align(Fl_Align(FL_ALIGN_TOP_LEFT));
          o->menu(menu_Type);
          o->value(pars->VoicePar[nvoice].PFMEnabled);
        } // Fl_Choice* o
        { Fl_Group* o = new Fl_Group(5, 250, 525, 120, "FREQUENCY");
          o->box(FL_THIN_UP_BOX);
          o->labelfont(1);
          o->labelsize(11);
          o->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
          { EnvelopeUI* o = voicefreqenvgroup = new EnvelopeUI(10, 295, 205, 70, "ADSynth Voice - Frequency Envelope");
            voicefreqenvgroup->box(FL_FLAT_BOX);
            voicefreqenvgroup->color((Fl_Color)51);
            voicefreqenvgroup->selection_color(FL_BACKGROUND_COLOR);
            voicefreqenvgroup->labeltype(FL_NORMAL_LABEL);
            voicefreqenvgroup->labelfont(0);
            voicefreqenvgroup->labelsize(14);
            voicefreqenvgroup->labelcolor(FL_FOREGROUND_COLOR);
            voicefreqenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
            voicefreqenvgroup->when(FL_WHEN_RELEASE);
            o->init(pars->VoicePar[nvoice].FreqEnvelope, npart, kititem, nvoice | 0x80, 1);
            if (pars->VoicePar[nvoice].PFreqEnvelopeEnabled==0) o->deactivate();
            voicefreqenvgroup->end();
          } // EnvelopeUI* voicefreqenvgroup
          { Fl_Check_Button* o = new Fl_Check_Button(15, 300, 50, 10, "Enable");
            o->tooltip("Forced Relase");
            o->down_box(FL_DOWN_BOX);
            o->labelfont(1);
            o->labelsize(10);
            o->callback((Fl_Callback*)cb_Enable2);
            o->value(pars->VoicePar[nvoice].PFreqEnvelopeEnabled);
          } // Fl_Check_Button* o
          { LFOUI* o = voicefreqlfogroup = new LFOUI(215, 295, 230, 70, "Frequency LFO     ");
            voicefreqlfogroup->box(FL_FLAT_BOX);
            voicefreqlfogroup->color(FL_DARK1);
            voicefreqlfogroup->selection_color(FL_BACKGROUND_COLOR);
            voicefreqlfogroup->labeltype(FL_NORMAL_LABEL);
            voicefreqlfogroup->labelfont(0);
            voicefreqlfogroup->labelsize(14);
            voicefreqlfogroup->labelcolor(FL_FOREGROUND_COLOR);
            voicefreqlfogroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
            voicefreqlfogroup->when(FL_WHEN_RELEASE);
            o->init(pars->VoicePar[nvoice].FreqLfo, npart, kititem, 128 + nvoice, 1);
            if (pars->VoicePar[nvoice].PFreqLfoEnabled==0) o->deactivate();
            voicefreqlfogroup->end();
          } // LFOUI* voicefreqlfogroup
          { Fl_Check_Button* o = new Fl_Check_Button(220, 300, 55, 10, "Enable");
            o->tooltip("Forced Relase");
            o->down_box(FL_DOWN_BOX);
            o->labelfont(1);
            o->labelsize(10);
            o->callback((Fl_Callback*)cb_Enable3);
            o->value(pars->VoicePar[nvoice].PFreqLfoEnabled);
          } // Fl_Check_Button* o
          { Fl_Counter* o = new Fl_Counter(464, 276, 45, 15, "Octave");
            o->tooltip("Octave");
            o->type(1);
            o->labelsize(10);
            o->minimum(-8);
            o->maximum(7);
            o->step(1);
            o->textfont(1);
            o->textsize(11);
            o->callback((Fl_Callback*)cb_Octave1);
            o->align(Fl_Align(FL_ALIGN_TOP));
            int k = pars->VoicePar[nvoice].PCoarseDetune / 1024;
            if (k >= 8) k -= 16;
            o->value(k);
          } // Fl_Counter* o
          { Fl_Counter* o = new Fl_Counter(455, 345, 60, 20, "Coarse Det.");
            o->tooltip("Coarse Detune");
            o->labelsize(10);
            o->minimum(-64);
            o->maximum(63);
            o->step(1);
            o->textfont(1);
            o->textsize(11);
            o->callback((Fl_Callback*)cb_Coarse1);
            o->align(Fl_Align(FL_ALIGN_TOP));
            int k = pars->VoicePar[nvoice].PCoarseDetune % 1024;
            if (k >= 512) k -= 1024;
            o->value(k);
            o->lstep(10);
          } // Fl_Counter* o
          { Fl_Value_Output* o = detunevalueoutput = new Fl_Value_Output(10, 276, 38, 16, "Detune");
            detunevalueoutput->box(FL_THIN_DOWN_BOX);
            detunevalueoutput->labelsize(10);
            detunevalueoutput->minimum(-5000);
            detunevalueoutput->maximum(5000);
            detunevalueoutput->textfont(1);
            detunevalueoutput->textsize(10);
            detunevalueoutput->callback((Fl_Callback*)cb_detunevalueoutput1);
            detunevalueoutput->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->step(0.01, 1);
            o->value(getDetune((pars->VoicePar[nvoice].PDetuneType==0)?(pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PDetuneType),0,pars->VoicePar[nvoice].PDetune)*pars->getBandwidthDetuneMultiplier());
          } // Fl_Value_Output* detunevalueoutput
          { mwheel_slider_rev* o = new mwheel_slider_rev(48, 276, 397, 16);
            o->tooltip("Fine Detune (cents)");
            o->type(5);
            o->box(FL_THIN_DOWN_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(14);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->minimum(-8192);
            o->maximum(8191);
            o->step(1);
            o->callback((Fl_Callback*)cb_1);
            o->align(Fl_Align(FL_ALIGN_BOTTOM));
            o->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].PDetune-8192);
          } // mwheel_slider_rev* o
          { Fl_Check_Button* o = Freq440 = new Fl_Check_Button(340, 256, 55, 15, "440Hz");
            Freq440->tooltip("Set the voice base frequency to 440Hz");
            Freq440->down_box(FL_DOWN_BOX);
            Freq440->labelfont(1);
            Freq440->labelsize(11);
            Freq440->callback((Fl_Callback*)cb_Freq440);
            o->value(pars->VoicePar[nvoice].Pfixedfreq);
          } // Fl_Check_Button* Freq440
          { WidgetPDial* o = fixedfreqetdial = new WidgetPDial(400, 254, 20, 20, "Eq.T.");
            fixedfreqetdial->tooltip("How the frequency varies according to the keyboard (leftmost for fixed freque\
ncy)");
            fixedfreqetdial->box(FL_ROUND_UP_BOX);
            fixedfreqetdial->color(FL_BACKGROUND_COLOR);
            fixedfreqetdial->selection_color(FL_INACTIVE_COLOR);
            fixedfreqetdial->labeltype(FL_NORMAL_LABEL);
            fixedfreqetdial->labelfont(0);
            fixedfreqetdial->labelsize(10);
            fixedfreqetdial->labelcolor(FL_FOREGROUND_COLOR);
            fixedfreqetdial->maximum(127);
            fixedfreqetdial->step(1);
            fixedfreqetdial->callback((Fl_Callback*)cb_fixedfreqetdial);
            fixedfreqetdial->align(Fl_Align(FL_ALIGN_RIGHT));
            fixedfreqetdial->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].PfixedfreqET);
            if (pars->VoicePar[nvoice].Pfixedfreq==0) o->deactivate();
            o->init(0);
          } // WidgetPDial* fixedfreqetdial
          { Fl_Choice* o = new Fl_Choice(450, 310, 75, 15, "Detune Type");
            o->down_box(FL_BORDER_BOX);
            o->labelsize(10);
            o->textfont(1);
            o->textsize(10);
            o->callback((Fl_Callback*)cb_Detune1);
            o->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->add("Default");o->add("L35cents");o->add("L10cents");o->add("E100cents");o->add("E1200cents");
            o->value(pars->VoicePar[nvoice].PDetuneType);
          } // Fl_Choice* o
          { WidgetPDial* o = bend = new WidgetPDial(70, 254, 20, 20, "Bend");
            bend->tooltip("How the frequency varies according to the pitch wheel");
            bend->box(FL_ROUND_UP_BOX);
            bend->color(FL_BACKGROUND_COLOR);
            bend->selection_color(FL_INACTIVE_COLOR);
            bend->labeltype(FL_NORMAL_LABEL);
            bend->labelfont(0);
            bend->labelsize(10);
            bend->labelcolor(FL_FOREGROUND_COLOR);
            bend->maximum(127);
            bend->step(1);
            bend->callback((Fl_Callback*)cb_bend);
            bend->align(Fl_Align(FL_ALIGN_RIGHT));
            bend->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].PBendAdjust);
            o->init(88);
          } // WidgetPDial* bend
          { WidgetPDial* o = offset = new WidgetPDial(130, 254, 20, 20, "Offset");
            offset->tooltip("Offset of the frequency in Hz.");
            offset->box(FL_ROUND_UP_BOX);
            offset->color(FL_BACKGROUND_COLOR);
            offset->selection_color(FL_INACTIVE_COLOR);
            offset->labeltype(FL_NORMAL_LABEL);
            offset->labelfont(0);
            offset->labelsize(10);
            offset->labelcolor(FL_FOREGROUND_COLOR);
            offset->maximum(127);
            offset->step(1);
            offset->callback((Fl_Callback*)cb_offset);
            offset->align(Fl_Align(FL_ALIGN_RIGHT));
            offset->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].POffsetHz);
            o->init(64);
          } // WidgetPDial* offset
          o->end();
        } // Fl_Group* o
        { Fl_Group* o = voiceoscil = new Fl_Group(80, 375, 445, 145);
          voiceoscil->box(FL_THIN_DOWN_BOX);
          voiceoscil->color(FL_GRAY0);
          voiceoscil->selection_color((Fl_Color)71);
          voiceoscil->labelcolor((Fl_Color)179);
          osc = new Oscilloscope(o->x(),o->y(),o->w(),o->h(), "");
          //
                int nv = nvoice;
                if (pars->VoicePar[nvoice].Pextoscil >= 0)
                    nv = pars->VoicePar[nvoice].Pextoscil;
          //
                osc->init(pars->VoicePar[nv].OscilSmp, 0,
                          pars->VoicePar[nvoice].Poscilphase, synth);
          voiceoscil->end();
        } // Fl_Group* voiceoscil
        { Fl_Button* o = changevoiceoscilbutton = new Fl_Button(5, 475, 65, 20, "Change");
          changevoiceoscilbutton->box(FL_THIN_UP_BOX);
          changevoiceoscilbutton->labelfont(1);
          changevoiceoscilbutton->labelsize(11);
          changevoiceoscilbutton->callback((Fl_Callback*)cb_changevoiceoscilbutton);
          if (pars->VoicePar[nvoice].Pextoscil>=0) o->labelcolor(FL_BLUE);
        } // Fl_Button* changevoiceoscilbutton
        { Fl_Box* o = new Fl_Box(5, 375, 75, 35, "Voice Oscillator");
          o->labelfont(1);
          o->labelsize(12);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        { mwheel_slider_rev* o = new mwheel_slider_rev(9, 420, 65, 12, "Phase");
          o->type(5);
          o->box(FL_THIN_DOWN_BOX);
          o->color(FL_BACKGROUND_COLOR);
          o->selection_color(FL_BACKGROUND_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(10);
          o->labelcolor(FL_FOREGROUND_COLOR);
          o->minimum(-64);
          o->maximum(63);
          o->step(1);
          o->callback((Fl_Callback*)cb_Phase1);
          o->align(Fl_Align(FL_ALIGN_TOP));
          o->when(FL_WHEN_CHANGED);
          o->value(64-pars->VoicePar[nvoice].Poscilphase);
        } // mwheel_slider_rev* o
        { Fl_Box* o = new Fl_Box(200, 5, 45, 35);
          o->box(FL_THIN_UP_FRAME);
        } // Fl_Box* o
        { Fl_Check_Button* o = new Fl_Check_Button(215, 20, 17, 19, "Reson");
          o->tooltip("Resonance On/Off");
          o->down_box(FL_DOWN_BOX);
          o->labelfont(1);
          o->labelsize(11);
          o->callback((Fl_Callback*)cb_Reson);
          o->align(Fl_Align(FL_ALIGN_TOP));
          o->value(pars->VoicePar[nvoice].Presonance);
        } // Fl_Check_Button* o
        { Fl_Choice* o = new Fl_Choice(5, 455, 65, 15, "Use Oscil.");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(10);
          o->textfont(1);
          o->textsize(10);
          o->callback((Fl_Callback*)cb_Use1);
          o->align(Fl_Align(FL_ALIGN_TOP));
          o->add("Internal");
          char tmp[50]; for (int i = 0; i < nvoice; ++i) {sprintf(tmp, "Ext.%2d", i + 1); o->add(tmp);};
          o->value(pars->VoicePar[nvoice].Pextoscil + 1);
        } // Fl_Choice* o
        { Fl_Check_Button* o = new Fl_Check_Button(31, 543, 19, 15, "Unison");
          o->tooltip("Enable/Disable");
          o->down_box(FL_DOWN_BOX);
          o->labelfont(1);
          o->labelsize(12);
          o->callback((Fl_Callback*)cb_Unison);
          o->align(Fl_Align(FL_ALIGN_TOP));
          int tmp = (pars->VoicePar[nvoice].Unison_size);
          o->value(tmp > 1);
        } // Fl_Check_Button* o
        { Fl_Group* o = unisongroup = new Fl_Group(80, 524, 445, 48);
          unisongroup->box(FL_PLASTIC_UP_BOX);
          unisongroup->color((Fl_Color)231);
          unisongroup->deactivate();
          { Fl_Spinner* o = unisonsize = new Fl_Spinner(90, 544, 40, 16, "Size");
            unisonsize->tooltip("Number of unison sub-voices");
            unisonsize->box(FL_THIN_UP_BOX);
            unisonsize->color(FL_BACKGROUND2_COLOR);
            unisonsize->labelfont(1);
            unisonsize->labelsize(11);
            unisonsize->minimum(2);
            unisonsize->maximum(50);
            unisonsize->value(2);
            unisonsize->textsize(12);
            unisonsize->callback((Fl_Callback*)cb_unisonsize);
            unisonsize->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            int tmp = pars->VoicePar[nvoice].Unison_size;
            if (tmp < 2) tmp = 2;
            o->value(tmp);
          } // Fl_Spinner* unisonsize
          { WidgetPDial* o = new WidgetPDial(349, 540, 25, 25, "Stereo");
            o->tooltip("Stereo Spread");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(10);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_Stereo);
            o->align(Fl_Align(FL_ALIGN_TOP));
            o->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_stereo_spread);
            o->init(64);
          } // WidgetPDial* o
          { WidgetPDial* o = new WidgetPDial(384, 540, 25, 25, "Vib.");
            o->tooltip("Vibratto");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(10);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_Vib);
            o->align(Fl_Align(FL_ALIGN_TOP));
            o->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_vibratto);
            o->init(64);
          } // WidgetPDial* o
          { Fl_Choice* o = new Fl_Choice(451, 545, 67, 15, "Invert");
            o->tooltip("Phase Invert");
            o->down_box(FL_BORDER_BOX);
            o->labelsize(11);
            o->textfont(1);
            o->textsize(10);
            o->callback((Fl_Callback*)cb_Invert);
            o->align(Fl_Align(FL_ALIGN_TOP));
            //
                  o->add("None");
                  o->add("Random");
                  //char tmp[100];
                  for (int i = 2; i <= 5; ++i)
                  {
                      string tmp = asString(100 / i) + string(" %");
                      o->add(tmp.c_str());
                  }
            o->value(pars->VoicePar[nvoice].Unison_invert_phase);
          } // Fl_Choice* o
          { mwheel_slider_rev* o = new mwheel_slider_rev(185, 545, 120, 16, "Frequency Spread");
            o->tooltip("Frequency Spread of the Unison");
            o->type(5);
            o->box(FL_THIN_DOWN_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(12);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->value(64);
            o->callback((Fl_Callback*)cb_Frequency);
            o->align(Fl_Align(FL_ALIGN_TOP_RIGHT));
            o->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_frequency_spread);
          } // mwheel_slider_rev* o
          { Fl_Value_Output* o = unisonspreadoutput = new Fl_Value_Output(150, 545, 38, 16, "(cents)");
            unisonspreadoutput->box(FL_THIN_DOWN_BOX);
            unisonspreadoutput->labelsize(10);
            unisonspreadoutput->maximum(1000);
            unisonspreadoutput->textfont(1);
            unisonspreadoutput->textsize(10);
            unisonspreadoutput->callback((Fl_Callback*)cb_unisonspreadoutput);
            unisonspreadoutput->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->step(0.1, 1);
            o->value(pars->getUnisonFrequencySpreadCents(nvoice));
          } // Fl_Value_Output* unisonspreadoutput
          { WidgetPDial* o = new WidgetPDial(420, 540, 25, 25, "V.speed");
            o->tooltip("Vibratto Average Speed");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(10);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_V1);
            o->align(Fl_Align(FL_ALIGN_TOP));
            o->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_vibratto_speed);
            o->init(64);
          } // WidgetPDial* o
          { WidgetPDial* o = new WidgetPDial(315, 540, 25, 25, "Ph.rnd");
            o->tooltip("Phase randomness");
            o->box(FL_ROUND_UP_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_INACTIVE_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(10);
            o->labelcolor(FL_FOREGROUND_COLOR);
            o->maximum(127);
            o->step(1);
            o->callback((Fl_Callback*)cb_Ph);
            o->align(Fl_Align(FL_ALIGN_TOP_RIGHT));
            o->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_phase_randomness);
            o->init(127);
          } // WidgetPDial* o
          int tmp = pars->VoicePar[nvoice].Unison_size; if (tmp > 1) o->activate();
          unisonsize->labelcolor(FL_BLACK);int i = -1; while (true){ i++; if(pars->ADnote_unison_sizes[i] == 0) break; if (pars->ADnote_unison_sizes[i] == tmp){ unisonsize->labelcolor(FL_RED); break;}}
          unisongroup->end();
        } // Fl_Group* unisongroup
        voicemodegroup->end();
      } // Fl_Group* voicemodegroup
      { amplitudegroup = new Fl_Group(5, 40, 240, 210, "AMPLITUDE");
        amplitudegroup->box(FL_THIN_UP_BOX);
        amplitudegroup->labelfont(1);
        amplitudegroup->labelsize(11);
        amplitudegroup->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
        { WidgetPDial* o = voicevolume = new WidgetPDial(42, 56, 34, 34, "Volume");
          voicevolume->tooltip("Volume");
          voicevolume->box(FL_ROUND_UP_BOX);
          voicevolume->color(FL_BACKGROUND_COLOR);
          voicevolume->selection_color(FL_INACTIVE_COLOR);
          voicevolume->labeltype(FL_NORMAL_LABEL);
          voicevolume->labelfont(0);
          voicevolume->labelsize(10);
          voicevolume->labelcolor(FL_FOREGROUND_COLOR);
          voicevolume->maximum(127);
          voicevolume->step(1);
          voicevolume->callback((Fl_Callback*)cb_voicevolume1);
          voicevolume->align(Fl_Align(FL_ALIGN_BOTTOM));
          voicevolume->when(FL_WHEN_CHANGED);
          o->value(pars->VoicePar[nvoice].PVolume);
          o->init(100);
        } // WidgetPDial* voicevolume
        { WidgetPDial* o = new WidgetPDial(107, 56, 34, 34, "Vel Sens");
          o->tooltip("Velocity Sensing Function - rightmost/max disables)");
          o->box(FL_ROUND_UP_BOX);
          o->color(FL_BACKGROUND_COLOR);
          o->selection_color(FL_INACTIVE_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(10);
          o->labelcolor(FL_FOREGROUND_COLOR);
          o->maximum(127);
          o->step(1);
          o->callback((Fl_Callback*)cb_Vel);
          o->align(Fl_Align(FL_ALIGN_BOTTOM));
          o->when(FL_WHEN_CHANGED);
          o->value(pars->VoicePar[nvoice].PAmpVelocityScaleFunction);
          o->init(127);
        } // WidgetPDial* o
        { EnvelopeUI* o = voiceampenvgroup = new EnvelopeUI(10, 105, 205, 70, "ADSynth Voice - Amplitude Envelope");
          voiceampenvgroup->box(FL_FLAT_BOX);
          voiceampenvgroup->color((Fl_Color)51);
          voiceampenvgroup->selection_color(FL_BACKGROUND_COLOR);
          voiceampenvgroup->labeltype(FL_NORMAL_LABEL);
          voiceampenvgroup->labelfont(0);
          voiceampenvgroup->labelsize(14);
          voiceampenvgroup->labelcolor(FL_FOREGROUND_COLOR);
          voiceampenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          voiceampenvgroup->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].AmpEnvelope, npart, kititem, nvoice | 0x80, 0);
          if (!pars->VoicePar[nvoice].PAmpEnvelopeEnabled) o->deactivate();
          voiceampenvgroup->end();
        } // EnvelopeUI* voiceampenvgroup
        { WidgetPDial* o = voicepan = new WidgetPDial(174, 56, 34, 34, "Pan");
          voicepan->tooltip("Voice panning - leftmost/zero gives random panning");
          voicepan->box(FL_ROUND_UP_BOX);
          voicepan->color(FL_BACKGROUND_COLOR);
          voicepan->selection_color(FL_INACTIVE_COLOR);
          voicepan->labeltype(FL_NORMAL_LABEL);
          voicepan->labelfont(0);
          voicepan->labelsize(10);
          voicepan->labelcolor(FL_FOREGROUND_COLOR);
          voicepan->maximum(127);
          voicepan->step(1);
          voicepan->callback((Fl_Callback*)cb_voicepan);
          voicepan->align(Fl_Align(FL_ALIGN_BOTTOM_LEFT));
          voicepan->when(FL_WHEN_CHANGED);
          o->value(pars->VoicePar[nvoice].PPanning);
          o->init(64);
        } // WidgetPDial* voicepan
        { Fl_Light_Button* o = voicerandompan = new Fl_Light_Button(196, 91, 13, 13, "Rand");
          voicerandompan->tooltip("Voice random panning On/Off");
          voicerandompan->box(FL_NO_BOX);
          voicerandompan->color((Fl_Color)35);
          voicerandompan->selection_color(FL_RED);
          voicerandompan->labelsize(10);
          voicerandompan->callback((Fl_Callback*)cb_voicerandompan);
          voicerandompan->align(Fl_Align(72));
          o->value(pars->randomVoicePan(nvoice));
        } // Fl_Light_Button* voicerandompan
        { Fl_Check_Button* o = new Fl_Check_Button(15, 110, 50, 10, "Enable");
          o->tooltip("Forced Relase");
          o->down_box(FL_DOWN_BOX);
          o->labelfont(1);
          o->labelsize(10);
          o->callback((Fl_Callback*)cb_Enable4);
          o->value(pars->VoicePar[nvoice].PAmpEnvelopeEnabled);
        } // Fl_Check_Button* o
        { LFOUI* o = voiceamplfogroup = new LFOUI(10, 175, 230, 70, "Amplitude LFO     ");
          voiceamplfogroup->box(FL_FLAT_BOX);
          voiceamplfogroup->color(FL_DARK1);
          voiceamplfogroup->selection_color(FL_BACKGROUND_COLOR);
          voiceamplfogroup->labeltype(FL_NORMAL_LABEL);
          voiceamplfogroup->labelfont(0);
          voiceamplfogroup->labelsize(14);
          voiceamplfogroup->labelcolor(FL_FOREGROUND_COLOR);
          voiceamplfogroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          voiceamplfogroup->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].AmpLfo, npart, kititem, 128 + nvoice, 0);
          if (pars->VoicePar[nvoice].PAmpLfoEnabled==0) o->deactivate();
          voiceamplfogroup->end();
        } // LFOUI* voiceamplfogroup
        { Fl_Check_Button* o = new Fl_Check_Button(15, 180, 55, 10, "Enable");
          o->tooltip("Forced Relase");
          o->down_box(FL_DOWN_BOX);
          o->labelfont(1);
          o->labelsize(10);
          o->callback((Fl_Callback*)cb_Enable5);
          o->value(pars->VoicePar[nvoice].PAmpLfoEnabled);
        } // Fl_Check_Button* o
        { Fl_Check_Button* o = new Fl_Check_Button(10, 45, 50, 10, "Minus");
          o->tooltip("Invert volume control action");
          o->down_box(FL_DOWN_BOX);
          o->labelfont(1);
          o->labelsize(10);
          o->callback((Fl_Callback*)cb_Minus);
          o->value(pars->VoicePar[nvoice].PVolumeminus);
        } // Fl_Check_Button* o
        amplitudegroup->end();
      } // Fl_Group* amplitudegroup
      { Fl_Group* o = voicefiltergroup = new Fl_Group(245, 5, 285, 245, "FILTER");
        voicefiltergroup->box(FL_THIN_UP_FRAME);
        voicefiltergroup->labelfont(1);
        voicefiltergroup->labelsize(11);
        voicefiltergroup->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
        { FilterUI* o = new FilterUI(250, 30, 275, 75, "ADsynth Voice - Filter");
          o->box(FL_FLAT_BOX);
          o->color(FL_LIGHT1);
          o->selection_color(FL_BACKGROUND_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(14);
          o->labelcolor(FL_FOREGROUND_COLOR);
          o->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          o->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].VoiceFilter,&pars->VoicePar[nvoice].PFilterVelocityScale, &pars->VoicePar[nvoice].PFilterVelocityScaleFunction, npart, kititem, 128 + nvoice);
          o->end();
        } // FilterUI* o
        { EnvelopeUI* o = voicefilterenvgroup = new EnvelopeUI(250, 105, 275, 70, "ADSynth Voice - Filter Envelope");
          voicefilterenvgroup->box(FL_FLAT_BOX);
          voicefilterenvgroup->color((Fl_Color)51);
          voicefilterenvgroup->selection_color(FL_BACKGROUND_COLOR);
          voicefilterenvgroup->labeltype(FL_NORMAL_LABEL);
          voicefilterenvgroup->labelfont(0);
          voicefilterenvgroup->labelsize(14);
          voicefilterenvgroup->labelcolor(FL_FOREGROUND_COLOR);
          voicefilterenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          voicefilterenvgroup->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].FilterEnvelope, npart, kititem, nvoice | 0x80, 2);
          if (pars->VoicePar[nvoice].PFilterEnvelopeEnabled==0) o->deactivate();
          voicefilterenvgroup->end();
        } // EnvelopeUI* voicefilterenvgroup
        { Fl_Check_Button* o = new Fl_Check_Button(255, 110, 55, 10, "Enable");
          o->tooltip("Forced Relase");
          o->down_box(FL_DOWN_BOX);
          o->labelfont(1);
          o->labelsize(10);
          o->callback((Fl_Callback*)cb_Enable6);
          o->value(pars->VoicePar[nvoice].PFilterEnvelopeEnabled);
        } // Fl_Check_Button* o
        { LFOUI* o = voicefilterlfogroup = new LFOUI(250, 175, 230, 70, "Filter LFO     ");
          voicefilterlfogroup->box(FL_FLAT_BOX);
          voicefilterlfogroup->color(FL_DARK1);
          voicefilterlfogroup->selection_color(FL_BACKGROUND_COLOR);
          voicefilterlfogroup->labeltype(FL_NORMAL_LABEL);
          voicefilterlfogroup->labelfont(0);
          voicefilterlfogroup->labelsize(14);
          voicefilterlfogroup->labelcolor(FL_FOREGROUND_COLOR);
          voicefilterlfogroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          voicefilterlfogroup->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].FilterLfo, npart, kititem, 128 + nvoice, 2);
          if (pars->VoicePar[nvoice].PFilterLfoEnabled==0) o->deactivate();
          voicefilterlfogroup->end();
        } // LFOUI* voicefilterlfogroup
        { Fl_Check_Button* o = new Fl_Check_Button(255, 180, 55, 10, "Enable");
          o->tooltip("Forced Relase");
          o->down_box(FL_DOWN_BOX);
          o->labelfont(1);
          o->labelsize(10);
          o->callback((Fl_Callback*)cb_Enable7);
          o->value(pars->VoicePar[nvoice].PFilterLfoEnabled);
        } // Fl_Check_Button* o
        if (pars->VoicePar[nvoice].PFilterEnabled==0) o->deactivate();
        voicefiltergroup->end();
      } // Fl_Group* voicefiltergroup
      { Fl_Group* o = new Fl_Group(5, 5, 55, 35, "1");
        o->box(FL_THIN_UP_BOX);
        o->labeltype(FL_EMBOSSED_LABEL);
        o->labelfont(1);
        o->labelsize(22);
        o->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
        //
              char tmp[2]; tmp[0] = nvoice + 49; tmp[1] = 0; o->copy_label(tmp);
        o->end();
      } // Fl_Group* o
      { Fl_Choice* o = new Fl_Choice(5, 500, 65, 20);
        o->tooltip("Oscillator Type (sound/noise)");
        o->down_box(FL_BORDER_BOX);
        o->labelsize(10);
        o->textfont(1);
        o->textsize(10);
        o->callback((Fl_Callback*)cb_2);
        o->when(FL_WHEN_RELEASE_ALWAYS);
        o->menu(menu_);
        o->value(pars->VoicePar[nvoice].Type);
        if (pars->VoicePar[nvoice].Type!=0) voicemodegroup->deactivate();
      } // Fl_Choice* o
      { Fl_Group* o = new Fl_Group(106, 5, 95, 35);
        o->box(FL_THIN_UP_BOX);
        { mwheel_val_slider_rev* o = new mwheel_val_slider_rev(111, 21, 84, 12, "Delay");
          o->tooltip("Volume");
          o->type(5);
          o->box(FL_THIN_DOWN_BOX);
          o->color(FL_BACKGROUND_COLOR);
          o->selection_color(FL_BACKGROUND_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(11);
          o->labelcolor(FL_FOREGROUND_COLOR);
          o->maximum(127);
          o->step(1);
          o->callback((Fl_Callback*)cb_Delay);
          o->align(Fl_Align(FL_ALIGN_TOP));
          o->when(FL_WHEN_CHANGED);
          o->value(pars->VoicePar[nvoice].PDelay);
        } // mwheel_val_slider_rev* o
        o->end();
      } // Fl_Group* o
      { Fl_Check_Button* o = bypassfiltercheckbutton = new Fl_Check_Button(416, 16, 14, 14, "Bypass Global F.");
        bypassfiltercheckbutton->down_box(FL_DOWN_BOX);
        bypassfiltercheckbutton->labelfont(1);
        bypassfiltercheckbutton->labelsize(10);
        bypassfiltercheckbutton->callback((Fl_Callback*)cb_bypassfiltercheckbutton);
        bypassfiltercheckbutton->align(Fl_Align(FL_ALIGN_RIGHT));
        o->value(pars->VoicePar[nvoice].Pfilterbypass);
      } // Fl_Check_Button* bypassfiltercheckbutton
      { Fl_Check_Button* o = new Fl_Check_Button(250, 15, 60, 15, "Enable");
        o->tooltip("Enable Filter");
        o->down_box(FL_DOWN_BOX);
        o->labelfont(1);
        o->labelsize(10);
        o->callback((Fl_Callback*)cb_Enable8);
        o->value(pars->VoicePar[nvoice].PFilterEnabled);
      } // Fl_Check_Button* o
      { Fl_Box* o = noiselabel = new Fl_Box(150, 415, 300, 65, "Noise");
        noiselabel->labelfont(1);
        noiselabel->labelsize(50);
        noiselabel->labelcolor(FL_BACKGROUND2_COLOR);
        noiselabel->callback((Fl_Callback*)cb_noiselabel1);
        o->hide(); int tmp = pars->VoicePar[nvoice].Type;
        if (tmp == 1) {o->copy_label("White Noise"); o->labelcolor(7);} else if (tmp > 1) {o->copy_label("Pink Noise"); o->labelcolor(5);}
        if (tmp > 0) o->show();
      } // Fl_Box* noiselabel
      if (pars->VoicePar[nvoice].Enabled==0) o->deactivate();
      voiceparametersgroup->end();
    } // Fl_Group* voiceparametersgroup
    { Fl_Check_Button* o = voiceonbutton = new Fl_Check_Button(60, 5, 47, 35, "On");
      voiceonbutton->box(FL_THIN_UP_BOX);
      voiceonbutton->down_box(FL_DOWN_BOX);
      voiceonbutton->labelfont(1);
      voiceonbutton->labelsize(13);
      voiceonbutton->callback((Fl_Callback*)cb_voiceonbutton);
      o->value(pars->VoicePar[nvoice].Enabled);
    } // Fl_Check_Button* voiceonbutton
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("AddSynth Voice Oscillator").c_str());
    ADnoteVoiceParameters->end();
  } // Fl_Group* ADnoteVoiceParameters
  return ADnoteVoiceParameters;
}

ADvoiceUI::ADvoiceUI(int x,int y, int w, int h, const char *label):Fl_Group(x,y,w,h,label) {
  //
          nvoice = 0;
          pars = NULL;
          oscedit = NULL;
}

void ADvoiceUI::send_data(int control, float value, bool isInteger ) {
  //
  synth->commandFetch(value, (Fl::event_button() | 0x20 | (isInteger << 7)), control, npart, kititem, nvoice | 0x80);
}

void ADvoiceUI::init(ADnoteParameters *parameters,int npart_, int kititem_, int nvoice_) {
  //
  	synth = parameters->getSynthEngine();
          pars = parameters;
          npart = npart_;
          kititem = kititem_;
          nvoice = nvoice_;
          make_window();
          end();
          ADnoteVoiceParameters->show();
}

ADvoiceUI::~ADvoiceUI() {
  //
          ADnoteVoiceParameters->hide();
          hide();
          if (oscedit)
          {
              delete oscedit;
          }
          //delete (ADnoteVoiceParameters);
}

void ADnoteUI::cb_octave_i(Fl_Counter* o, void*) {
  //
    int k = lrint(o->value());
    if (k < 0)
        k += 16;
    pars->GlobalPar.PCoarseDetune = k * 1024 + pars->GlobalPar.PCoarseDetune % 1024;
    send_data(35, o->value());
}
void ADnoteUI::cb_octave(Fl_Counter* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_octave_i(o,v);
}

void ADnoteUI::cb_coarsedet_i(Fl_Counter* o, void*) {
  //
    int k = lrint(o->value());
    if (k < 0)
        k += 1024;
    pars->GlobalPar.PCoarseDetune = k + (pars->GlobalPar.PCoarseDetune / 1024) * 1024;
    send_data(37, o->value());
}
void ADnoteUI::cb_coarsedet(Fl_Counter* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_coarsedet_i(o,v);
}

void ADnoteUI::cb_freq_i(mwheel_slider_rev* o, void*) {
  //
    if (Fl::event_button() == 3)
        o->value(0);
    pars->GlobalPar.PDetune = lrint(o->value()) + 8192;
    detunevalueoutput->do_callback();
    send_data(32, o->value() + 8192);
}
void ADnoteUI::cb_freq(mwheel_slider_rev* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_freq_i(o,v);
}

void ADnoteUI::cb_detunevalueoutput2_i(Fl_Value_Output* o, void*) {
  o->value(getDetune(pars->GlobalPar.PDetuneType,0,pars->GlobalPar.PDetune));
}
void ADnoteUI::cb_detunevalueoutput2(Fl_Value_Output* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_detunevalueoutput2_i(o,v);
}

void ADnoteUI::cb_detunetype_i(Fl_Choice* o, void*) {
  //
    pars->GlobalPar.PDetuneType = lrint(o->value()) + 1;
    detunevalueoutput->do_callback();
    send_data(36, o->value() + 1);
}
void ADnoteUI::cb_detunetype(Fl_Choice* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_detunetype_i(o,v);
}

void ADnoteUI::cb_relBW_i(WidgetPDial* o, void*) {
  //
    pars->GlobalPar.PBandwidth = lrint(o->value());
    pars->getBandwidthDetuneMultiplier();
    for (int i = 0; i < NUM_VOICES; ++i)
    {
        voicelistitem[i]->refreshlist();
    }
    send_data(39, o->value());
}
void ADnoteUI::cb_relBW(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_relBW_i(o,v);
}

void ADnoteUI::cb_globalvolume_i(WidgetPDial* o, void*) {
  pars->GlobalPar.PVolume = lrint(o->value());
send_data(0, o->value());
}
void ADnoteUI::cb_globalvolume(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_globalvolume_i(o,v);
}

void ADnoteUI::cb_vsns_i(WidgetPDial* o, void*) {
  pars->GlobalPar.PAmpVelocityScaleFunction = lrint(o->value());
send_data(1, o->value());
}
void ADnoteUI::cb_vsns(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_vsns_i(o,v);
}

void ADnoteUI::cb_globalpan_i(WidgetPDial* o, void*) {
  //
    pars->setGlobalPan(lrint(o->value()));
    globalrandompan->value(pars->randomGlobalPan());
    amplitudegrp->changed();
    send_data(2, o->value());
}
void ADnoteUI::cb_globalpan(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_globalpan_i(o,v);
}

void ADnoteUI::cb_globalrandompan_i(Fl_Light_Button* o, void*) {
  //
              if (pars->randomGlobalPan()) // set to full left
              {
                  globalpan->value(1);
                  pars->setGlobalPan(1);
              }
              o->value(pars->randomGlobalPan());
}
void ADnoteUI::cb_globalrandompan(Fl_Light_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_globalrandompan_i(o,v);
}

void ADnoteUI::cb_depop_i(WidgetPDial* o, void*) {
  pars->GlobalPar.Fadein_adjustment = lrint(o->value());
send_data(120, o->value());
}
void ADnoteUI::cb_depop(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_depop_i(o,v);
}

void ADnoteUI::cb_pstr_i(WidgetPDial* o, void*) {
  pars->GlobalPar.PPunchStrength = lrint(o->value());
send_data(121, o->value());
}
void ADnoteUI::cb_pstr(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_pstr_i(o,v);
}

void ADnoteUI::cb_pt_i(WidgetPDial* o, void*) {
  pars->GlobalPar.PPunchTime = lrint(o->value());
send_data(122, o->value());
}
void ADnoteUI::cb_pt(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_pt_i(o,v);
}

void ADnoteUI::cb_pstc_i(WidgetPDial* o, void*) {
  pars->GlobalPar.PPunchStretch = lrint(o->value());
send_data(123, o->value());
}
void ADnoteUI::cb_pstc(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_pstc_i(o,v);
}

void ADnoteUI::cb_pvel_i(WidgetPDial* o, void*) {
  pars->GlobalPar.PPunchVelocitySensing = lrint(o->value());
send_data(124, o->value());
}
void ADnoteUI::cb_pvel(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_pvel_i(o,v);
}

void ADnoteUI::cb_rndgrp_i(Fl_Check_Button* o, void*) {
  pars->GlobalPar.Hrandgrouping = lrint(o->value());
send_data(113, o->value());
}
void ADnoteUI::cb_rndgrp(Fl_Check_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_rndgrp_i(o,v);
}

void ADnoteUI::cb_stereo_i(Fl_Check_Button* o, void*) {
  pars->GlobalPar.PStereo = lrint(o->value());
send_data(112, o->value());
}
void ADnoteUI::cb_stereo(Fl_Check_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_stereo_i(o,v);
}

void ADnoteUI::cb_Show_i(Fl_Button*, void*) {
  //
    for (int i = 0; i < NUM_VOICES; ++i)
        voicelistitem[i]->refreshlist();
    ADnoteVoiceList->show();
    if ((Fl::event_button() == 3))
        ADnoteGlobalParameters->hide();
}
void ADnoteUI::cb_Show(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Show_i(o,v);
}

void ADnoteUI::cb_Show1_i(Fl_Button*, void*) {
  //
    voicelistitem[nvoice]->refreshlist();
    ADnoteVoice->show();
    ADnoteVoice->redraw();
    if ((Fl::event_button() == 3))
        ADnoteGlobalParameters->hide();
}
void ADnoteUI::cb_Show1(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Show1_i(o,v);
}

void ADnoteUI::cb_Close_i(Fl_Button*, void*) {
  synth->getGuiMaster()->addNoteX = ADnoteGlobalParameters->x();
synth->getGuiMaster()->addNoteY = ADnoteGlobalParameters->y();
ADnoteGlobalParameters->hide();
if ((Fl::event_button() == 3))
{
    if (synth->getGuiMaster()->partui->partKitOn)
        synth->getGuiMaster()->partui->instrumentkitlist->show();
    else
        synth->getGuiMaster()->partui->instrumenteditwindow->show();
};
}
void ADnoteUI::cb_Close(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void ADnoteUI::cb_Resonance_i(Fl_Button*, void*) {
  //
    resui->resonancewindow->redraw();
    resui->Show(true);
    if ((Fl::event_button() == 3))
        ADnoteGlobalParameters->hide();
}
void ADnoteUI::cb_Resonance(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Resonance_i(o,v);
}

void ADnoteUI::cb_C_i(Fl_Button*, void*) {
  synth->getGuiMaster()->getPresetsUi()->copy(pars);
}
void ADnoteUI::cb_C(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_C_i(o,v);
}

void ADnoteUI::cb_P_i(Fl_Button*, void*) {
  synth->getGuiMaster()->getPresetsUi()->paste(pars,this);
}
void ADnoteUI::cb_P(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_P_i(o,v);
}

void ADnoteUI::cb_currentvoicecounter_i(Fl_Spinner* o, void*) {
  //
            nvoice = lrint(o->value()) - 1;
            advoice->hide();
            ADnoteVoice->remove(advoice);
            delete advoice;
            advoice = new ADvoiceUI(0, 0, 765, 585);
            ADnoteVoice->add(advoice);
            advoice->init(pars, npart, kititem, nvoice);
            advoice->show();
            ADnoteVoice->redraw();
}
void ADnoteUI::cb_currentvoicecounter(Fl_Spinner* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_currentvoicecounter_i(o,v);
}

void ADnoteUI::cb_Close1_i(Fl_Button*, void*) {
  ADnoteVoice->hide();
if ((Fl::event_button() == 3))
    ADnoteGlobalParameters->show();
}
void ADnoteUI::cb_Close1(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Close1_i(o,v);
}

void ADnoteUI::cb_C1_i(Fl_Button*, void*) {
  synth->getGuiMaster()->getPresetsUi()->copy(pars,nvoice);
}
void ADnoteUI::cb_C1(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_C1_i(o,v);
}

void ADnoteUI::cb_P1_i(Fl_Button*, void*) {
  synth->getGuiMaster()->getPresetsUi()->paste(pars,this,nvoice);
}
void ADnoteUI::cb_P1(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_P1_i(o,v);
}

void ADnoteUI::cb_Close2_i(Fl_Button*, void*) {
  ADnoteVoiceList->hide();
if ((Fl::event_button() == 3))
    ADnoteGlobalParameters->show();
}
void ADnoteUI::cb_Close2(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Close2_i(o,v);
}

Fl_Double_Window* ADnoteUI::make_window() {
  { Fl_Double_Window* o = ADnoteGlobalParameters = new Fl_Double_Window(535, 405, "ADsynth Global Parameters of the Instrument");
    ADnoteGlobalParameters->user_data((void*)(this));
    { Fl_Group* o = new Fl_Group(5, 255, 525, 115, "FREQUENCY");
      o->box(FL_THIN_UP_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
      { EnvelopeUI* o = freqenv = new EnvelopeUI(10, 295, 205, 70, "ADSynth Global - Frequency Envelope");
        freqenv->box(FL_FLAT_BOX);
        freqenv->color((Fl_Color)51);
        freqenv->selection_color(FL_BACKGROUND_COLOR);
        freqenv->labeltype(FL_NORMAL_LABEL);
        freqenv->labelfont(0);
        freqenv->labelsize(12);
        freqenv->labelcolor(FL_FOREGROUND_COLOR);
        freqenv->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        freqenv->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.FreqEnvelope, npart, kititem, 0, 1);
        freqenv->end();
      } // EnvelopeUI* freqenv
      { Fl_Counter* o = octave = new Fl_Counter(450, 275, 45, 15, "Octave");
        octave->tooltip("Octave");
        octave->type(1);
        octave->labelsize(10);
        octave->minimum(-8);
        octave->maximum(7);
        octave->step(1);
        octave->textfont(1);
        octave->textsize(11);
        octave->callback((Fl_Callback*)cb_octave);
        octave->align(Fl_Align(FL_ALIGN_TOP));
        int k = pars->GlobalPar.PCoarseDetune / 1024; if (k >= 8) k -= 16;
        o->value(k);
      } // Fl_Counter* octave
      { Fl_Counter* o = coarsedet = new Fl_Counter(455, 345, 60, 20, "Coarse det.");
        coarsedet->tooltip("Coarse Detune");
        coarsedet->labelsize(10);
        coarsedet->minimum(-64);
        coarsedet->maximum(63);
        coarsedet->step(1);
        coarsedet->textfont(1);
        coarsedet->textsize(11);
        coarsedet->callback((Fl_Callback*)cb_coarsedet);
        coarsedet->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        int k = pars->GlobalPar.PCoarseDetune % 1024; if (k >= 512) k -= 1024;
        o->value(k);
        o->lstep(10);
      } // Fl_Counter* coarsedet
      { LFOUI* o = freqlfo = new LFOUI(215, 295, 230, 70, "Frequency LFO     ");
        freqlfo->box(FL_FLAT_BOX);
        freqlfo->color(FL_DARK1);
        freqlfo->selection_color(FL_BACKGROUND_COLOR);
        freqlfo->labeltype(FL_NORMAL_LABEL);
        freqlfo->labelfont(0);
        freqlfo->labelsize(12);
        freqlfo->labelcolor(FL_FOREGROUND_COLOR);
        freqlfo->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        freqlfo->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.FreqLfo, npart, kititem, 0, 1);
        freqlfo->end();
      } // LFOUI* freqlfo
      { mwheel_slider_rev* o = freq = new mwheel_slider_rev(57, 275, 385, 15);
        freq->tooltip("Fine Detune (cents)");
        freq->type(5);
        freq->box(FL_THIN_DOWN_BOX);
        freq->color(FL_BACKGROUND_COLOR);
        freq->selection_color(FL_BACKGROUND_COLOR);
        freq->labeltype(FL_NORMAL_LABEL);
        freq->labelfont(0);
        freq->labelsize(14);
        freq->labelcolor(FL_FOREGROUND_COLOR);
        freq->minimum(-8192);
        freq->maximum(8191);
        freq->step(1);
        freq->callback((Fl_Callback*)cb_freq);
        freq->align(Fl_Align(FL_ALIGN_BOTTOM));
        freq->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PDetune - 8192);
      } // mwheel_slider_rev* freq
      { Fl_Value_Output* o = detunevalueoutput = new Fl_Value_Output(12, 275, 45, 15, "Detune");
        detunevalueoutput->labelsize(10);
        detunevalueoutput->minimum(-5000);
        detunevalueoutput->maximum(5000);
        detunevalueoutput->textfont(1);
        detunevalueoutput->textsize(10);
        detunevalueoutput->callback((Fl_Callback*)cb_detunevalueoutput2);
        detunevalueoutput->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        o->step(0.01, 1);
        o->value(getDetune(pars->GlobalPar.PDetuneType, 0, pars->GlobalPar.PDetune));
      } // Fl_Value_Output* detunevalueoutput
      { Fl_Choice* o = detunetype = new Fl_Choice(450, 315, 75, 15, "Detune Type");
        detunetype->down_box(FL_BORDER_BOX);
        detunetype->labelsize(10);
        detunetype->textfont(1);
        detunetype->textsize(10);
        detunetype->callback((Fl_Callback*)cb_detunetype);
        detunetype->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        //
              o->add("L35cents");
              o->add("L10cents");
              o->add("E100cents");
              o->add("E1200cents");
        o->value(pars->GlobalPar.PDetuneType-1);
      } // Fl_Choice* detunetype
      { WidgetPDial* o = new WidgetPDial(500, 270, 25, 25, "relBW");
        o->tooltip("Bandwidth - how the relative fine detune of the voice are changed");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(0);
        o->labelsize(10);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->step(1);
        o->callback((Fl_Callback*)cb_relBW);
        o->align(Fl_Align(FL_ALIGN_TOP));
        o->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PBandwidth);
        o->init(64);
      } // WidgetPDial* o
      o->end();
    } // Fl_Group* o
    { amplitudegrp = new Fl_Group(5, 5, 240, 250, "AMPLITUDE");
      amplitudegrp->box(FL_THIN_UP_FRAME);
      amplitudegrp->labeltype(FL_EMBOSSED_LABEL);
      amplitudegrp->labelsize(11);
      amplitudegrp->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
      { WidgetPDial* o = globalvolume = new WidgetPDial(39, 22, 35, 35, "Volume");
        globalvolume->tooltip("Volume");
        globalvolume->box(FL_ROUND_UP_BOX);
        globalvolume->color(FL_BACKGROUND_COLOR);
        globalvolume->selection_color(FL_INACTIVE_COLOR);
        globalvolume->labeltype(FL_NORMAL_LABEL);
        globalvolume->labelfont(0);
        globalvolume->labelsize(10);
        globalvolume->labelcolor(FL_FOREGROUND_COLOR);
        globalvolume->maximum(127);
        globalvolume->step(1);
        globalvolume->callback((Fl_Callback*)cb_globalvolume);
        globalvolume->align(Fl_Align(FL_ALIGN_BOTTOM));
        globalvolume->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PVolume);
        o->init(90);
      } // WidgetPDial* globalvolume
      { WidgetPDial* o = vsns = new WidgetPDial(106, 22, 35, 35, "Vel Sens");
        vsns->tooltip("Velocity Sensing Function - rightmost/max to disable");
        vsns->box(FL_ROUND_UP_BOX);
        vsns->color(FL_BACKGROUND_COLOR);
        vsns->selection_color(FL_INACTIVE_COLOR);
        vsns->labeltype(FL_NORMAL_LABEL);
        vsns->labelfont(0);
        vsns->labelsize(10);
        vsns->labelcolor(FL_FOREGROUND_COLOR);
        vsns->maximum(127);
        vsns->step(1);
        vsns->callback((Fl_Callback*)cb_vsns);
        vsns->align(Fl_Align(FL_ALIGN_BOTTOM));
        vsns->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PAmpVelocityScaleFunction);
        o->init(64);
      } // WidgetPDial* vsns
      { WidgetPDial* o = globalpan = new WidgetPDial(173, 22, 35, 35, "Pan");
        globalpan->tooltip("Global panning - leftmost/zero gives random panning");
        globalpan->box(FL_ROUND_UP_BOX);
        globalpan->color(FL_BACKGROUND_COLOR);
        globalpan->selection_color(FL_INACTIVE_COLOR);
        globalpan->labeltype(FL_NORMAL_LABEL);
        globalpan->labelfont(0);
        globalpan->labelsize(10);
        globalpan->labelcolor(FL_FOREGROUND_COLOR);
        globalpan->maximum(127);
        globalpan->step(1);
        globalpan->callback((Fl_Callback*)cb_globalpan);
        globalpan->align(Fl_Align(FL_ALIGN_BOTTOM_LEFT));
        globalpan->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PPanning);
        o->init(64);
      } // WidgetPDial* globalpan
      { Fl_Light_Button* o = globalrandompan = new Fl_Light_Button(194, 57, 13, 13, "Rand");
        globalrandompan->box(FL_NO_BOX);
        globalrandompan->color((Fl_Color)35);
        globalrandompan->selection_color(FL_RED);
        globalrandompan->labelsize(10);
        globalrandompan->callback((Fl_Callback*)cb_globalrandompan);
        o->value(pars->randomGlobalPan());
      } // Fl_Light_Button* globalrandompan
      { WidgetPDial* o = depop = new WidgetPDial(85, 227, 25, 25, "D.Pop");
        depop->tooltip("Pop Suppression");
        depop->box(FL_ROUND_UP_BOX);
        depop->color(FL_BACKGROUND_COLOR);
        depop->selection_color(FL_INACTIVE_COLOR);
        depop->labeltype(FL_NORMAL_LABEL);
        depop->labelfont(0);
        depop->labelsize(10);
        depop->labelcolor(FL_FOREGROUND_COLOR);
        depop->maximum(127);
        depop->step(1);
        depop->callback((Fl_Callback*)cb_depop);
        depop->align(Fl_Align(FL_ALIGN_TOP));
        depop->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.Fadein_adjustment);
        o->init(20);
      } // WidgetPDial* depop
      { WidgetPDial* o = pstr = new WidgetPDial(125, 227, 25, 25, "P.Str.");
        pstr->tooltip("Punch Strength");
        pstr->box(FL_ROUND_UP_BOX);
        pstr->color(FL_BACKGROUND_COLOR);
        pstr->selection_color(FL_INACTIVE_COLOR);
        pstr->labeltype(FL_NORMAL_LABEL);
        pstr->labelfont(0);
        pstr->labelsize(10);
        pstr->labelcolor(FL_FOREGROUND_COLOR);
        pstr->maximum(127);
        pstr->step(1);
        pstr->callback((Fl_Callback*)cb_pstr);
        pstr->align(Fl_Align(FL_ALIGN_TOP));
        pstr->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PPunchStrength);
        o->init(0);
      } // WidgetPDial* pstr
      { WidgetPDial* o = pt = new WidgetPDial(155, 227, 25, 25, "P.t.");
        pt->tooltip("Punch Time (duration)");
        pt->box(FL_ROUND_UP_BOX);
        pt->color(FL_BACKGROUND_COLOR);
        pt->selection_color(FL_INACTIVE_COLOR);
        pt->labeltype(FL_NORMAL_LABEL);
        pt->labelfont(0);
        pt->labelsize(10);
        pt->labelcolor(FL_FOREGROUND_COLOR);
        pt->maximum(127);
        pt->step(1);
        pt->callback((Fl_Callback*)cb_pt);
        pt->align(Fl_Align(FL_ALIGN_TOP));
        pt->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PPunchTime);
        o->init(60);
      } // WidgetPDial* pt
      { WidgetPDial* o = pstc = new WidgetPDial(185, 227, 25, 25, "P.Stc.");
        pstc->tooltip("Punch Stretch");
        pstc->box(FL_ROUND_UP_BOX);
        pstc->color(FL_BACKGROUND_COLOR);
        pstc->selection_color(FL_INACTIVE_COLOR);
        pstc->labeltype(FL_NORMAL_LABEL);
        pstc->labelfont(0);
        pstc->labelsize(10);
        pstc->labelcolor(FL_FOREGROUND_COLOR);
        pstc->maximum(127);
        pstc->step(1);
        pstc->callback((Fl_Callback*)cb_pstc);
        pstc->align(Fl_Align(FL_ALIGN_TOP));
        pstc->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PPunchStretch);
        o->init(64);
      } // WidgetPDial* pstc
      { WidgetPDial* o = pvel = new WidgetPDial(215, 227, 25, 25, "P.Vel.");
        pvel->tooltip("Punch Velocity Sensing");
        pvel->box(FL_ROUND_UP_BOX);
        pvel->color(FL_BACKGROUND_COLOR);
        pvel->selection_color(FL_INACTIVE_COLOR);
        pvel->labeltype(FL_NORMAL_LABEL);
        pvel->labelfont(0);
        pvel->labelsize(10);
        pvel->labelcolor(FL_FOREGROUND_COLOR);
        pvel->maximum(127);
        pvel->step(1);
        pvel->callback((Fl_Callback*)cb_pvel);
        pvel->align(Fl_Align(FL_ALIGN_TOP));
        pvel->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PPunchVelocitySensing);
        o->init(72);
      } // WidgetPDial* pvel
      { EnvelopeUI* o = ampenv = new EnvelopeUI(10, 75, 205, 70, "ADSynth Global - Amplitude Envelope");
        ampenv->box(FL_FLAT_BOX);
        ampenv->color((Fl_Color)51);
        ampenv->selection_color(FL_BACKGROUND_COLOR);
        ampenv->labeltype(FL_NORMAL_LABEL);
        ampenv->labelfont(0);
        ampenv->labelsize(12);
        ampenv->labelcolor(FL_FOREGROUND_COLOR);
        ampenv->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        ampenv->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.AmpEnvelope, npart, kititem, 0, 0);
        ampenv->end();
      } // EnvelopeUI* ampenv
      { LFOUI* o = amplfo = new LFOUI(10, 145, 230, 70, "Amplitude LFO          ");
        amplfo->box(FL_FLAT_BOX);
        amplfo->color(FL_DARK1);
        amplfo->selection_color(FL_BACKGROUND_COLOR);
        amplfo->labeltype(FL_NORMAL_LABEL);
        amplfo->labelfont(0);
        amplfo->labelsize(12);
        amplfo->labelcolor(FL_FOREGROUND_COLOR);
        amplfo->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        amplfo->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.AmpLfo, npart, kititem, 0, 0);
        amplfo->end();
      } // LFOUI* amplfo
      { Fl_Check_Button* o = rndgrp = new Fl_Check_Button(8, 231, 63, 18, "Rnd Grp");
        rndgrp->tooltip("How the Harmonic Amplitude is applied to voices that use the same oscillator");
        rndgrp->down_box(FL_DOWN_BOX);
        rndgrp->labelsize(11);
        rndgrp->callback((Fl_Callback*)cb_rndgrp);
        o->value(pars->GlobalPar.Hrandgrouping);
      } // Fl_Check_Button* rndgrp
      amplitudegrp->end();
    } // Fl_Group* amplitudegrp
    { Fl_Group* o = new Fl_Group(245, 5, 285, 250, "FILTER");
      o->box(FL_THIN_UP_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
      { EnvelopeUI* o = filterenv = new EnvelopeUI(250, 110, 275, 70, "ADSynth Global - Filter Envelope");
        filterenv->box(FL_FLAT_BOX);
        filterenv->color((Fl_Color)51);
        filterenv->selection_color(FL_BACKGROUND_COLOR);
        filterenv->labeltype(FL_NORMAL_LABEL);
        filterenv->labelfont(0);
        filterenv->labelsize(12);
        filterenv->labelcolor(FL_FOREGROUND_COLOR);
        filterenv->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        filterenv->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.FilterEnvelope, npart, kititem, 0, 2);
        filterenv->end();
      } // EnvelopeUI* filterenv
      { LFOUI* o = filterlfo = new LFOUI(250, 180, 230, 70, "Filter LFO");
        filterlfo->box(FL_FLAT_BOX);
        filterlfo->color(FL_DARK1);
        filterlfo->selection_color(FL_BACKGROUND_COLOR);
        filterlfo->labeltype(FL_NORMAL_LABEL);
        filterlfo->labelfont(0);
        filterlfo->labelsize(12);
        filterlfo->labelcolor(FL_FOREGROUND_COLOR);
        filterlfo->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        filterlfo->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.FilterLfo, npart, kititem, 0, 2);
        filterlfo->end();
      } // LFOUI* filterlfo
      { FilterUI* o = filterui = new FilterUI(250, 35, 275, 75, "ADsynth Global - Filter");
        filterui->box(FL_FLAT_BOX);
        filterui->color(FL_LIGHT1);
        filterui->selection_color(FL_BACKGROUND_COLOR);
        filterui->labeltype(FL_NORMAL_LABEL);
        filterui->labelfont(0);
        filterui->labelsize(12);
        filterui->labelcolor(FL_FOREGROUND_COLOR);
        filterui->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        filterui->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.GlobalFilter, &pars->GlobalPar.PFilterVelocityScale, &pars->GlobalPar.PFilterVelocityScaleFunction, npart, kititem, 0);
        filterui->end();
      } // FilterUI* filterui
      o->end();
    } // Fl_Group* o
    { Fl_Check_Button* o = stereo = new Fl_Check_Button(8, 220, 65, 18, "Stereo");
      stereo->down_box(FL_DOWN_BOX);
      stereo->labelsize(11);
      stereo->callback((Fl_Callback*)cb_stereo);
      o->value(pars->GlobalPar.PStereo);
    } // Fl_Check_Button* stereo
    { Fl_Button* o = new Fl_Button(190, 375, 115, 25, "Show Voice List");
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Show);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(5, 375, 180, 25, "Show Voice Parameters");
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Show1);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(470, 375, 60, 25, "Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(309, 375, 86, 25, "Resonance");
      o->tooltip("Resonance");
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Resonance);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(405, 380, 25, 15, "C");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_C);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(435, 380, 25, 15, "P");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_P);
    } // Fl_Button* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("AddSynth Global").c_str());
    o->position(synth->getGuiMaster()->addNoteX, synth->getGuiMaster()->addNoteY);
    ADnoteGlobalParameters->end();
  } // Fl_Double_Window* ADnoteGlobalParameters
  { Fl_Double_Window* o = ADnoteVoice = new Fl_Double_Window(765, 615, "ADsynth Voice Parameters");
    ADnoteVoice->user_data((void*)(this));
    { ADvoiceUI* o = advoice = new ADvoiceUI(0, 0, 760, 575);
      advoice->box(FL_BORDER_BOX);
      advoice->color(FL_BACKGROUND_COLOR);
      advoice->selection_color(FL_BACKGROUND_COLOR);
      advoice->labeltype(FL_NORMAL_LABEL);
      advoice->labelfont(0);
      advoice->labelsize(14);
      advoice->labelcolor(FL_FOREGROUND_COLOR);
      advoice->align(Fl_Align(FL_ALIGN_TOP));
      advoice->when(FL_WHEN_RELEASE);
      o->init(pars, npart, kititem, nvoice);
      o->show();
      advoice->end();
    } // ADvoiceUI* advoice
    { currentvoicecounter = new Fl_Spinner(35, 584, 40, 24, "Current Voice");
      currentvoicecounter->labelfont(1);
      currentvoicecounter->labelsize(12);
      currentvoicecounter->maximum(8);
      currentvoicecounter->textfont(1);
      currentvoicecounter->callback((Fl_Callback*)cb_currentvoicecounter);
      currentvoicecounter->align(Fl_Align(FL_ALIGN_RIGHT));
    } // Fl_Spinner* currentvoicecounter
    { Fl_Button* o = new Fl_Button(655, 584, 90, 25, "Close");
      o->box(FL_THIN_UP_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close1);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(575, 589, 25, 15, "C");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_C1);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(605, 589, 25, 15, "P");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_P1);
    } // Fl_Button* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("AddSynth Voice").c_str());
    ADnoteVoice->end();
  } // Fl_Double_Window* ADnoteVoice
  { Fl_Double_Window* o = ADnoteVoiceList = new Fl_Double_Window(650, 260, "ADsynth Voices list");
    ADnoteVoiceList->user_data((void*)(this));
    { Fl_Text_Display* o = new Fl_Text_Display(30, 15, 30, 10, "No.");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(145, 15, 30, 10, "Volume");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(404, 15, 25, 10, "Detune");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(220, 15, 30, 10, "Pan");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(560, 15, 30, 10, "Vibrato Depth");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(258, 15, 25, 10, "Res");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Button* o = new Fl_Button(582, 235, 62, 20, "Close");
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close2);
    } // Fl_Button* o
    { Fl_Scroll* o = new Fl_Scroll(5, 15, 640, 214);
      o->type(2);
      o->box(FL_THIN_UP_BOX);
      { Fl_Pack* o = new Fl_Pack(17, 27, 620, 200);
        //
              for (int i = 0; i < NUM_VOICES; ++i)
              {
                  voicelistitem[i] = new ADvoicelistitem(4, 8, 620, 25, "");
                  voicelistitem[i]->init(pars, npart, kititem, i);
              }
        o->end();
      } // Fl_Pack* o
      o->end();
    } // Fl_Scroll* o
    { Fl_Text_Display* o = new Fl_Text_Display(73, 15, 30, 10, "Wave");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("AddSynth Voice List").c_str());
    ADnoteVoiceList->end();
  } // Fl_Double_Window* ADnoteVoiceList
  return ADnoteVoiceList;
}

void ADnoteUI::send_data(int control, float value, bool isInteger ) {
  //
  synth->commandFetch(value, (Fl::event_button() | 0x20 | (isInteger << 7)), control, npart, kititem, 0);
}

ADnoteUI::ADnoteUI(ADnoteParameters *parameters, int npart_, int kititem_) {
  //
  	synth = parameters->getSynthEngine();
          pars = parameters;
          npart = npart_;
          kititem = kititem_;
          nvoice = 0;
          resui = new ResonanceUI(pars->GlobalPar.Reson, npart, kititem, 0);
          make_window();
}

ADnoteUI::~ADnoteUI() {
  //
          ADnoteVoiceList->hide();
          ADnoteGlobalParameters->hide();
          ADnoteVoice->hide();
          delete ADnoteVoiceList;
          delete ADnoteGlobalParameters;
          delete ADnoteVoice;
          delete resui;
}

void ADnoteUI::refresh() {
  //
          globalvolume->value(pars->GlobalPar.PVolume);
          vsns->value(pars->GlobalPar.PAmpVelocityScaleFunction);
          globalpan->value(pars->GlobalPar.PPanning);
  
          stereo->value(pars->GlobalPar.PStereo);
          rndgrp->value(pars->GlobalPar.Hrandgrouping);
          pstr->value(pars->GlobalPar.PPunchStrength);
          pt->value(pars->GlobalPar.PPunchTime);
          pstc->value(pars->GlobalPar.PPunchStretch);
          pvel->value(pars->GlobalPar.PPunchVelocitySensing);
          detunevalueoutput->value(getDetune(pars->GlobalPar.PDetuneType, 0, pars->GlobalPar.PDetune));
          freq->value(pars->GlobalPar.PDetune - 8192);
  
          int k = pars->GlobalPar.PCoarseDetune / 1024;
          if (k >= 8)
              k -= 16;
          octave->value(k);
  
          detunetype->value(pars->GlobalPar.PDetuneType - 1);
          k = pars->GlobalPar.PCoarseDetune % 1024;
          if (k >= 512)
              k -= 1024;
          coarsedet->value(k);
          amplfo->refresh();
          freqlfo->refresh();
          filterlfo->refresh();
  
          ampenv->refresh();
          freqenv->refresh();
          filterenv->refresh();
          filterui->refresh();
          for (int i = 0; i < NUM_VOICES; ++i)
              voicelistitem[i]->refreshlist();
  
          resui->refresh();
          currentvoicecounter->do_callback();
}
