// ADNoteUI.h
// generated by Fast Light User Interface Designer (fluid) version 1.0303

#ifndef ADnoteUI_h
#define ADnoteUI_h
#include <FL/Fl.H>
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014-2016, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code, modified April 2011

#include "Misc/SynthHelper.h"
    #include "Misc/MiscFuncs.h"
    #include "ResonanceUI.h"
    #include <string>
    #include "EnvelopeUI.h"
    #include "LFOUI.h"
    #include "OscilGenUI.h"
#include <FL/Fl_Group.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Value_Output.H>

class ADvoicelistitem : public Fl_Group, SynthHelper {
  Fl_Group* make_window();
  Fl_Group *ADnoteVoiceListItem;
  Fl_Group *voicelistitemgroup;
public:
  mwheel_val_slider_rev *voicevolume;
private:
  inline void cb_voicevolume_i(mwheel_val_slider_rev*, void*);
  static void cb_voicevolume(mwheel_val_slider_rev*, void*);
public:
  Fl_Check_Button *voiceresonanceenabled;
private:
  inline void cb_voiceresonanceenabled_i(Fl_Check_Button*, void*);
  static void cb_voiceresonanceenabled(Fl_Check_Button*, void*);
public:
  mwheel_val_slider_rev *voicelfofreq;
private:
  inline void cb_voicelfofreq_i(mwheel_val_slider_rev*, void*);
  static void cb_voicelfofreq(mwheel_val_slider_rev*, void*);
public:
  WidgetPDial *voicepanning;
private:
  inline void cb_voicepanning_i(WidgetPDial*, void*);
  static void cb_voicepanning(WidgetPDial*, void*);
public:
  Fl_Group *voiceoscil;
  Fl_Box *noiselabel;
private:
  inline void cb_noiselabel_i(Fl_Box*, void*);
  static void cb_noiselabel(Fl_Box*, void*);
public:
  Fl_Value_Output *detunevalueoutput;
private:
  inline void cb_detunevalueoutput_i(Fl_Value_Output*, void*);
  static void cb_detunevalueoutput(Fl_Value_Output*, void*);
public:
  mwheel_slider_rev *voicedetune;
private:
  inline void cb_voicedetune_i(mwheel_slider_rev*, void*);
  static void cb_voicedetune(mwheel_slider_rev*, void*);
  Fl_Check_Button *voiceenabled;
  inline void cb_voiceenabled_i(Fl_Check_Button*, void*);
  static void cb_voiceenabled(Fl_Check_Button*, void*);
public:
  ADvoicelistitem(int x,int y, int w, int h, const char *label=0);
  void init(ADnoteParameters *parameters, int npart_, int kititem_, int nvoice_);
  void refreshlist();
  ~ADvoicelistitem();
private:
  ADnoteParameters *pars; 
public:
  int nvoice; 
private:
  Oscilloscope *osc; 
  SynthEngine *synth; 
  int npart; 
  int kititem; 
};
#include <FL/Fl_Counter.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Spinner.H>
#include <FL/Fl_Light_Button.H>

class ADvoiceUI : public Fl_Group, SynthHelper, MiscFuncs {
public:
  Fl_Group* make_window();
  Fl_Group *ADnoteVoiceParameters;
  Fl_Group *voiceparametersgroup;
  Fl_Group *voicemodegroup;
  Fl_Group *voiceFMparametersgroup;
  Fl_Group *modfrequency;
  EnvelopeUI *voiceFMfreqenvgroup;
private:
  inline void cb_Enable_i(Fl_Check_Button*, void*);
  static void cb_Enable(Fl_Check_Button*, void*);
  inline void cb_Coarse_i(Fl_Counter*, void*);
  static void cb_Coarse(Fl_Counter*, void*);
  inline void cb_Octave_i(Fl_Counter*, void*);
  static void cb_Octave(Fl_Counter*, void*);
public:
  Fl_Value_Output *fmdetunevalueoutput;
private:
  inline void cb_fmdetunevalueoutput_i(Fl_Value_Output*, void*);
  static void cb_fmdetunevalueoutput(Fl_Value_Output*, void*);
  inline void cb__i(mwheel_slider_rev*, void*);
  static void cb_(mwheel_slider_rev*, void*);
  inline void cb_Detune_i(Fl_Choice*, void*);
  static void cb_Detune(Fl_Choice*, void*);
public:
  Fl_Check_Button *Mod440;
private:
  inline void cb_Mod440_i(Fl_Check_Button*, void*);
  static void cb_Mod440(Fl_Check_Button*, void*);
  inline void cb_Vol_i(mwheel_val_slider_rev*, void*);
  static void cb_Vol(mwheel_val_slider_rev*, void*);
  inline void cb_V_i(mwheel_val_slider_rev*, void*);
  static void cb_V(mwheel_val_slider_rev*, void*);
public:
  EnvelopeUI *voiceFMampenvgroup;
private:
  inline void cb_Enable1_i(Fl_Check_Button*, void*);
  static void cb_Enable1(Fl_Check_Button*, void*);
  inline void cb_F_i(mwheel_val_slider_rev*, void*);
  static void cb_F(mwheel_val_slider_rev*, void*);
public:
  Fl_Group *modoscil;
  Fl_Group *fmoscil;
  Fl_Button *changeFMoscilbutton;
private:
  inline void cb_changeFMoscilbutton_i(Fl_Button*, void*);
  static void cb_changeFMoscilbutton(Fl_Button*, void*);
  inline void cb_Phase_i(mwheel_slider_rev*, void*);
  static void cb_Phase(mwheel_slider_rev*, void*);
  inline void cb_Use_i(Fl_Choice*, void*);
  static void cb_Use(Fl_Choice*, void*);
  inline void cb_External_i(Fl_Choice*, void*);
  static void cb_External(Fl_Choice*, void*);
  inline void cb_Type_i(Fl_Choice*, void*);
  static void cb_Type(Fl_Choice*, void*);
  static Fl_Menu_Item menu_Type[];
public:
  EnvelopeUI *voicefreqenvgroup;
private:
  inline void cb_Enable2_i(Fl_Check_Button*, void*);
  static void cb_Enable2(Fl_Check_Button*, void*);
public:
  LFOUI *voicefreqlfogroup;
private:
  inline void cb_Enable3_i(Fl_Check_Button*, void*);
  static void cb_Enable3(Fl_Check_Button*, void*);
  inline void cb_Octave1_i(Fl_Counter*, void*);
  static void cb_Octave1(Fl_Counter*, void*);
  inline void cb_Coarse1_i(Fl_Counter*, void*);
  static void cb_Coarse1(Fl_Counter*, void*);
public:
  Fl_Value_Output *detunevalueoutput;
private:
  inline void cb_detunevalueoutput1_i(Fl_Value_Output*, void*);
  static void cb_detunevalueoutput1(Fl_Value_Output*, void*);
  inline void cb_1_i(mwheel_slider_rev*, void*);
  static void cb_1(mwheel_slider_rev*, void*);
public:
  Fl_Check_Button *Freq440;
private:
  inline void cb_Freq440_i(Fl_Check_Button*, void*);
  static void cb_Freq440(Fl_Check_Button*, void*);
public:
  WidgetPDial *fixedfreqetdial;
private:
  inline void cb_fixedfreqetdial_i(WidgetPDial*, void*);
  static void cb_fixedfreqetdial(WidgetPDial*, void*);
  inline void cb_Detune1_i(Fl_Choice*, void*);
  static void cb_Detune1(Fl_Choice*, void*);
public:
  WidgetPDial *bend;
private:
  inline void cb_bend_i(WidgetPDial*, void*);
  static void cb_bend(WidgetPDial*, void*);
public:
  WidgetPDial *offset;
private:
  inline void cb_offset_i(WidgetPDial*, void*);
  static void cb_offset(WidgetPDial*, void*);
public:
  Fl_Group *voiceoscil;
  Fl_Button *changevoiceoscilbutton;
private:
  inline void cb_changevoiceoscilbutton_i(Fl_Button*, void*);
  static void cb_changevoiceoscilbutton(Fl_Button*, void*);
  inline void cb_Phase1_i(mwheel_slider_rev*, void*);
  static void cb_Phase1(mwheel_slider_rev*, void*);
  inline void cb_Reson_i(Fl_Check_Button*, void*);
  static void cb_Reson(Fl_Check_Button*, void*);
  inline void cb_Use1_i(Fl_Choice*, void*);
  static void cb_Use1(Fl_Choice*, void*);
  inline void cb_Unison_i(Fl_Check_Button*, void*);
  static void cb_Unison(Fl_Check_Button*, void*);
public:
  Fl_Group *unisongroup;
  Fl_Spinner *unisonsize;
private:
  inline void cb_unisonsize_i(Fl_Spinner*, void*);
  static void cb_unisonsize(Fl_Spinner*, void*);
  inline void cb_Stereo_i(WidgetPDial*, void*);
  static void cb_Stereo(WidgetPDial*, void*);
  inline void cb_Vib_i(WidgetPDial*, void*);
  static void cb_Vib(WidgetPDial*, void*);
  inline void cb_Invert_i(Fl_Choice*, void*);
  static void cb_Invert(Fl_Choice*, void*);
  inline void cb_Frequency_i(mwheel_slider_rev*, void*);
  static void cb_Frequency(mwheel_slider_rev*, void*);
public:
  Fl_Value_Output *unisonspreadoutput;
private:
  inline void cb_unisonspreadoutput_i(Fl_Value_Output*, void*);
  static void cb_unisonspreadoutput(Fl_Value_Output*, void*);
  inline void cb_V1_i(WidgetPDial*, void*);
  static void cb_V1(WidgetPDial*, void*);
  inline void cb_Ph_i(WidgetPDial*, void*);
  static void cb_Ph(WidgetPDial*, void*);
public:
  Fl_Group *amplitudegroup;
  WidgetPDial *voicevolume;
private:
  inline void cb_voicevolume1_i(WidgetPDial*, void*);
  static void cb_voicevolume1(WidgetPDial*, void*);
  inline void cb_Vel_i(WidgetPDial*, void*);
  static void cb_Vel(WidgetPDial*, void*);
public:
  EnvelopeUI *voiceampenvgroup;
  WidgetPDial *voicepan;
private:
  inline void cb_voicepan_i(WidgetPDial*, void*);
  static void cb_voicepan(WidgetPDial*, void*);
public:
  Fl_Light_Button *voicerandompan;
private:
  inline void cb_voicerandompan_i(Fl_Light_Button*, void*);
  static void cb_voicerandompan(Fl_Light_Button*, void*);
  inline void cb_Enable4_i(Fl_Check_Button*, void*);
  static void cb_Enable4(Fl_Check_Button*, void*);
public:
  LFOUI *voiceamplfogroup;
private:
  inline void cb_Enable5_i(Fl_Check_Button*, void*);
  static void cb_Enable5(Fl_Check_Button*, void*);
  inline void cb_Minus_i(Fl_Check_Button*, void*);
  static void cb_Minus(Fl_Check_Button*, void*);
public:
  Fl_Group *voicefiltergroup;
  EnvelopeUI *voicefilterenvgroup;
private:
  inline void cb_Enable6_i(Fl_Check_Button*, void*);
  static void cb_Enable6(Fl_Check_Button*, void*);
public:
  LFOUI *voicefilterlfogroup;
private:
  inline void cb_Enable7_i(Fl_Check_Button*, void*);
  static void cb_Enable7(Fl_Check_Button*, void*);
  inline void cb_2_i(Fl_Choice*, void*);
  static void cb_2(Fl_Choice*, void*);
  static Fl_Menu_Item menu_[];
  inline void cb_Delay_i(mwheel_val_slider_rev*, void*);
  static void cb_Delay(mwheel_val_slider_rev*, void*);
public:
  Fl_Check_Button *bypassfiltercheckbutton;
private:
  inline void cb_bypassfiltercheckbutton_i(Fl_Check_Button*, void*);
  static void cb_bypassfiltercheckbutton(Fl_Check_Button*, void*);
  inline void cb_Enable8_i(Fl_Check_Button*, void*);
  static void cb_Enable8(Fl_Check_Button*, void*);
public:
  Fl_Box *noiselabel;
private:
  inline void cb_noiselabel1_i(Fl_Box*, void*);
  static void cb_noiselabel1(Fl_Box*, void*);
public:
  Fl_Check_Button *voiceonbutton;
private:
  inline void cb_voiceonbutton_i(Fl_Check_Button*, void*);
  static void cb_voiceonbutton(Fl_Check_Button*, void*);
public:
  ADvoiceUI(int x,int y, int w, int h, const char *label=0);
  void send_data(int control, float value, bool isInteger = true);
  void init(ADnoteParameters *parameters,int npart_, int kititem_, int nvoice_);
  ~ADvoiceUI();
private:
  int nvoice; 
  int npart; 
  int kititem; 
  ADnoteParameters *pars; 
  OscilEditor *oscedit; 
  Oscilloscope *osc; 
  Oscilloscope *oscFM; 
  SynthEngine *synth; 
};
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Text_Display.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Pack.H>

class ADnoteUI : public PresetsUI_, SynthHelper {
  Fl_Double_Window* make_window();
public:
  Fl_Double_Window *ADnoteGlobalParameters;
  EnvelopeUI *freqenv;
  Fl_Counter *octave;
private:
  inline void cb_octave_i(Fl_Counter*, void*);
  static void cb_octave(Fl_Counter*, void*);
public:
  Fl_Counter *coarsedet;
private:
  inline void cb_coarsedet_i(Fl_Counter*, void*);
  static void cb_coarsedet(Fl_Counter*, void*);
public:
  LFOUI *freqlfo;
  mwheel_slider_rev *freq;
private:
  inline void cb_freq_i(mwheel_slider_rev*, void*);
  static void cb_freq(mwheel_slider_rev*, void*);
public:
  Fl_Value_Output *detunevalueoutput;
private:
  inline void cb_detunevalueoutput2_i(Fl_Value_Output*, void*);
  static void cb_detunevalueoutput2(Fl_Value_Output*, void*);
public:
  Fl_Choice *detunetype;
private:
  inline void cb_detunetype_i(Fl_Choice*, void*);
  static void cb_detunetype(Fl_Choice*, void*);
  inline void cb_relBW_i(WidgetPDial*, void*);
  static void cb_relBW(WidgetPDial*, void*);
public:
  Fl_Group *amplitudegrp;
  WidgetPDial *globalvolume;
private:
  inline void cb_globalvolume_i(WidgetPDial*, void*);
  static void cb_globalvolume(WidgetPDial*, void*);
public:
  WidgetPDial *vsns;
private:
  inline void cb_vsns_i(WidgetPDial*, void*);
  static void cb_vsns(WidgetPDial*, void*);
public:
  WidgetPDial *globalpan;
private:
  inline void cb_globalpan_i(WidgetPDial*, void*);
  static void cb_globalpan(WidgetPDial*, void*);
public:
  Fl_Light_Button *globalrandompan;
private:
  inline void cb_globalrandompan_i(Fl_Light_Button*, void*);
  static void cb_globalrandompan(Fl_Light_Button*, void*);
public:
  WidgetPDial *depop;
private:
  inline void cb_depop_i(WidgetPDial*, void*);
  static void cb_depop(WidgetPDial*, void*);
public:
  WidgetPDial *pstr;
private:
  inline void cb_pstr_i(WidgetPDial*, void*);
  static void cb_pstr(WidgetPDial*, void*);
public:
  WidgetPDial *pt;
private:
  inline void cb_pt_i(WidgetPDial*, void*);
  static void cb_pt(WidgetPDial*, void*);
public:
  WidgetPDial *pstc;
private:
  inline void cb_pstc_i(WidgetPDial*, void*);
  static void cb_pstc(WidgetPDial*, void*);
public:
  WidgetPDial *pvel;
private:
  inline void cb_pvel_i(WidgetPDial*, void*);
  static void cb_pvel(WidgetPDial*, void*);
public:
  EnvelopeUI *ampenv;
  LFOUI *amplfo;
  Fl_Check_Button *rndgrp;
private:
  inline void cb_rndgrp_i(Fl_Check_Button*, void*);
  static void cb_rndgrp(Fl_Check_Button*, void*);
public:
  EnvelopeUI *filterenv;
  LFOUI *filterlfo;
  FilterUI *filterui;
  Fl_Check_Button *stereo;
private:
  inline void cb_stereo_i(Fl_Check_Button*, void*);
  static void cb_stereo(Fl_Check_Button*, void*);
  inline void cb_Show_i(Fl_Button*, void*);
  static void cb_Show(Fl_Button*, void*);
  inline void cb_Show1_i(Fl_Button*, void*);
  static void cb_Show1(Fl_Button*, void*);
  inline void cb_Close_i(Fl_Button*, void*);
  static void cb_Close(Fl_Button*, void*);
  inline void cb_Resonance_i(Fl_Button*, void*);
  static void cb_Resonance(Fl_Button*, void*);
  inline void cb_C_i(Fl_Button*, void*);
  static void cb_C(Fl_Button*, void*);
  inline void cb_P_i(Fl_Button*, void*);
  static void cb_P(Fl_Button*, void*);
public:
  Fl_Double_Window *ADnoteVoice;
  ADvoiceUI *advoice;
  Fl_Spinner *currentvoicecounter;
private:
  inline void cb_currentvoicecounter_i(Fl_Spinner*, void*);
  static void cb_currentvoicecounter(Fl_Spinner*, void*);
  inline void cb_Close1_i(Fl_Button*, void*);
  static void cb_Close1(Fl_Button*, void*);
  inline void cb_C1_i(Fl_Button*, void*);
  static void cb_C1(Fl_Button*, void*);
  inline void cb_P1_i(Fl_Button*, void*);
  static void cb_P1(Fl_Button*, void*);
public:
  Fl_Double_Window *ADnoteVoiceList;
private:
  inline void cb_Close2_i(Fl_Button*, void*);
  static void cb_Close2(Fl_Button*, void*);
public:
  void send_data(int control, float value, bool isInteger = true);
  ADnoteUI(ADnoteParameters *parameters, int npart_, int kititem_);
  virtual ~ADnoteUI();
  void refresh();
private:
  ADnoteParameters *pars; 
  ResonanceUI *resui; 
public:
  int nvoice; 
private:
  ADvoicelistitem *voicelistitem[NUM_VOICES]; 
  SynthEngine *synth; 
  int npart; 
  int kititem; 
};
#endif
